#!/bin/sh

if [ "x$1" = "x" ] ; then
 echo "Usage: $0 /path/to/qmaildir"
 exit 1
else
 destdir=$1
fi

if [ ! -d $destdir ] ; then
  echo "Qmail directory $destdir does not exists"
  echo "please rerun this script as $0 qmail-directory"
  exit 1
fi

if [ -f $destdir/bin/qmail-queue.kas ] ; then
  echo "Qmail client already installed"
  exit 1
fi

if [ ! -f $destdir/bin/qmail-queue ] ; then
  echo "Qmail plugin $destdir/bin/qmail-queue missing, cannot install"
  exit 1
fi

if [ ! -r /usr/local/ap-mailfilter3/bin/kas-qmail ] ; then
  echo "Cannot find /usr/local/ap-mailfilter3/bin/kas-qmail"
  exit 1
fi

mv $destdir/bin/qmail-queue $destdir/bin/qmail-queue.kas
cp /usr/local/ap-mailfilter3/bin/kas-qmail $destdir/bin/qmail-queue
chown qmailq $destdir/bin/qmail-queue
chgrp qmail $destdir/bin/qmail-queue
chmod 04755 $destdir/bin/qmail-queue
echo "Qmail plugin installed"

