#!/bin/sh

sleep 30

SFPATH=/usr/local/ap-mailfilter3
CCROOT=$SFPATH/control
CCBIN=$CCROOT/bin

GETCONF=$CCBIN/ap-mflt-getconf
INITCONF="$CCBIN/kas-initconf -s -q"
TAIL="tail -n 100"
MV="mv -f"
TOUCH=touch
LOGGER=logger

MOVELOGS="FilterStatLogFile UpdaterLogPath SFUpdatesLogPath ErrlogPath"
TAILLOGS="CCSyslogLogPath CCUpdaterLogPath CCKeepup2dateLogPath CCSLicenseLogPath"

FACILITY=`$GETCONF LogFacility`

_EUID=`id -u`
_EUID_MAILFLT3=`id -u mailflt3`

if [ "$_EUID" != "$_EUID_MAILFLT3" ]; then
  echo cannot run as `id -un`
  echo run: su mailflt3 -c $0 $*
##  exec su mailflt3 -c $0 $*
  exit 1
fi


for f in `$GETCONF $MOVELOGS` ; do
  if [ -s $f ] ; then
    if [ -e $f.5 ] ; then
      $MV $f.5 $f.6 
    fi
    if [ -e $f.4 ] ; then
      $MV $f.4 $f.5 
    fi
    if [ -e $f.3 ] ; then
      $MV $f.3 $f.4 
    fi
    if [ -e $f.2 ] ; then
      $MV $f.2 $f.3 
    fi
    if [ -e $f.1 ] ; then
      $MV $f.1 $f.2 
    fi
    if [ -e $f.0 ] ; then
      $MV $f.0 $f.1 
    fi
    $MV $f $f.0
    $TOUCH $f
  fi
done
$SFPATH/bin/kas-restart -q -f

#
# XXX
# Special processing for kas-thttpd log (which is not in configuration parameters...)
#

CC_LOG=$SFPATH/log/kas-thttpd.log

if [ -s $CC_LOG ] ; then
    if [ -e $CC_LOG.5 ] ; then
      $MV $CC_LOG.5 $CC_LOG.6 
    fi
    if [ -e $CC_LOG.4 ] ; then
      $MV $CC_LOG.4 $CC_LOG.5 
    fi
    if [ -e $CC_LOG.3 ] ; then
      $MV $CC_LOG.3 $CC_LOG.4 
    fi
    if [ -e $CC_LOG.2 ] ; then
      $MV $CC_LOG.2 $CC_LOG.3 
    fi
    if [ -e $CC_LOG.1 ] ; then
      $MV $CC_LOG.1 $CC_LOG.2 
    fi
    if [ -e $CC_LOG.0 ] ; then
      $MV $CC_LOG.0 $CC_LOG.1 
    fi
    $MV $CC_LOG $CC_LOG.0
    $SFPATH/bin/kas-restart -q -W
fi

for f in `$GETCONF $TAILLOGS` ; do
  if [ -s $f ] ; then
    $TAIL $f > $f.$$
    $MV $f.$$ $f  
  fi
done

echo KASNOTICE Logs have been rotated | $LOGGER -p $FACILITY.notice -t logrotate

$INITCONF
