#!/usr/local/ap-mailfilter3/bin/perl -w
#######################################################################
# CGI-specifics

use strict;
use CGI::Carp qw(carpout);
use Data::Dumper;

use vars qw($ROOT @ERR $ERRLOG_PATH);

BEGIN {
  require 'config.pl';

  srand( time() ^ ($$ + ($$ << 15)) );

  if( $ENV{SERVER_SOFTWARE} && $ENV{SERVER_SOFTWARE} ne 'shell' )
  {
    if( $ENV{SERVER_SOFTWARE} !~ /^Apache/i )
    {
      my $log_path = $ERRLOG_PATH = "$ROOT/log/error.log";
      if( -w $log_path )
      {
        if( open (HTTP_ERRORLOG, ">>$log_path") )
        {
          &carpout(\*HTTP_ERRORLOG);
        }
        else
        {
          $log_path = undef;
        }
      }
      else
      {
        $log_path = undef;
      }

      unless( $log_path )
      {
        open(HTTP_ERRORLOG, ">>/dev/null") or die("Unable to open /dev/null: $!\n");
        &carpout(\*HTTP_ERRORLOG);
      }
    }
  }
};

my %SAFEESCAPE_Entities = (
                            '<' => '&lt;',
                            '>' => '&gt;',
                            '&' => '&amp;',
                            '"' => '&quot;'
                          );

sub SafeEscapeHTML($)
{
  my ($res) = @_;
  $res =~ s/([&"<>])/$SAFEESCAPE_Entities{$1}/g;
  return $res;
}

1;
__END__
