#!/usr/local/ap-mailfilter3/bin/perl -w
#######################################################################
# Default paths and constants

use strict;
use POSIX qw(strftime mktime);
use Data::Dumper;
use Time::Local;
#use File::Copy;

#use vars qw($CONST $CONFIG @ERR);

BEGIN {
#  require 'const.pl';
#  require 'config.pl';
#  require 'conffiles.pl';
};


my %MONTH = (
              "ENE" => 1,                                     # ENE
              "ENERO" => 1,                                   # ENERO
              "Ene" => 1,                                     # Ene
              "Enero" => 1,                                   # Enero
              "GEN" => 1,                                     # GEN
              "GENNAIO" => 1,                                 # GENNAIO
              "Gen" => 1,                                     # Gen
              "Gennaio" => 1,                                 # Gennaio
              "JAN" => 1,                                     # JAN
              "JANUAR" => 1,                                  # JANUAR
              "JANUARY" => 1,                                 # JANUARY
              "JANVIER" => 1,                                 # JANVIER
              "Jan" => 1,                                     # Jan
              "Januar" => 1,                                  # Januar
              "January" => 1,                                 # January
              "Janvier" => 1,                                 # Janvier
              "J\xc4NNER" => 1,                               # JNNER
              "J\xe4nner" => 1,                               # Jnner
              "ene" => 1,                                     # ene
              "enero" => 1,                                   # enero
              "gen" => 1,                                     # gen
              "gennaio" => 1,                                 # gennaio
              "jan" => 1,                                     # jan
              "januar" => 1,                                  # januar
              "january" => 1,                                 # january
              "janvier" => 1,                                 # janvier
              "j\xe4nner" => 1,                               # jnner
              "\x9f\x8d\x82" => 1,                            # 
              "\x9f\x8d\x82\x80\x90\x9c" => 1,                # 
              "\x9f\x8d\x82\x80\x90\x9f" => 1,                # 
              "\x9f\xad\xa2" => 1,                            # 
              "\x9f\xad\xa2\xa0\xe0\xec" => 1,                # 
              "\x9f\xad\xa2\xa0\xe0\xef" => 1,                # 
              "\xc1\xa6\xc7" => 1,                            # 
              "\xc1\xa6\xc7\xb5\xbd\xcc" => 1,                # ǵ
              "\xc1\xa6\xc7\xbd\xcf" => 1,                    # ǽ
              "\xc1\xf6\xe7" => 1,                            # 
              "\xc1\xf6\xe7\xd5\xdd\xec" => 1,                # 
              "\xc1\xf6\xe7\xdd\xef" => 1,                    # 
              "\xcf\xbd\xb2" => 1,                            # Ͻ
              "\xcf\xbd\xb2\xb0\xc0\xcc" => 1,                # Ͻ
              "\xcf\xbd\xb2\xb0\xc0\xcf" => 1,                # Ͻ
              "\xcf\xdd\xd2" => 1,                            # 
              "\xcf\xdd\xd2\xd0\xe0\xec" => 1,                # 
              "\xcf\xdd\xd2\xd0\xe0\xef" => 1,                # 
              "\xd1\xce\xd7" => 1,                            # 
              "\xd1\xce\xd7\xc1\xd2\xd1" => 1,                # 
              "\xd1\xce\xd7\xc1\xd2\xd8" => 1,                # 
              "\xd3\xa6\xde" => 1,                            # Ӧ
              "\xd3\xa6\xde\xc5\xce\xd8" => 1,                # Ӧ
              "\xd3\xa6\xde\xce\xd1" => 1,                    # Ӧ
              "\xdf\xcd\xc2" => 1,                            # 
              "\xdf\xcd\xc2\xc0\xd0\xdc" => 1,                # 
              "\xdf\xcd\xc2\xc0\xd0\xdf" => 1,                # 
              "\xdf\xed\xe2" => 1,                            # 
              "\xdf\xed\xe2\xe0\xf0\xfc" => 1,                # 
              "\xdf\xed\xe2\xe0\xf0\xff" => 1,                # 
              "\xe1\xf6\xe7" => 1,                            # 
              "\xe1\xf6\xe7\xd5\xdd\xec" => 1,                # 
              "\xe1\xf6\xe7\xdd\xef" => 1,                    # 
              "\xef\xad\xa2" => 1,                            # ﭢ
              "\xef\xad\xa2\xa0\xe0\xec" => 1,                # ﭢ
              "\xef\xad\xa2\xa0\xe0\xef" => 1,                # ﭢ
              "\xef\xdd\xd2" => 1,                            # 
              "\xef\xdd\xd2\xd0\xe0\xec" => 1,                # 
              "\xef\xdd\xd2\xd0\xe0\xef" => 1,                # 
              "\xf1\xce\xd7" => 1,                            # 
              "\xf1\xce\xd7\xc1\xd2\xd1" => 1,                # 
              "\xf1\xce\xd7\xc1\xd2\xd8" => 1,                # 
              "\xf1\xee\xf7" => 1,                            # 
              "\xf1\xee\xf7\xe1\xf2\xf1" => 1,                # 
              "\xf1\xee\xf7\xe1\xf2\xf8" => 1,                # 
              "\xf3\xa6\xde" => 1,                            # 
              "\xf3\xa6\xde\xc5\xce\xd8" => 1,                # 
              "\xf3\xa6\xde\xce\xd1" => 1,                    # 
              "\xf3\xb6\xfe" => 1,                            # 
              "\xf3\xb6\xfe\xe5\xee\xf8" => 1,                # 
              "\xf3\xb6\xfe\xee\xf1" => 1,                    # 
              "\xff\xed\xe2" => 1,                            # 
              "\xff\xed\xe2\xe0\xf0\xfc" => 1,                # 
              "\xff\xed\xe2\xe0\xf0\xff" => 1,                # 
              "FEB" => 2,                                     # FEB
              "FEBBRAIO" => 2,                                # FEBBRAIO
              "FEBRERO" => 2,                                 # FEBRERO
              "FEBRUAR" => 2,                                 # FEBRUAR
              "FEBRUARY" => 2,                                # FEBRUARY
              "Feb" => 2,                                     # Feb
              "Febbraio" => 2,                                # Febbraio
              "Febrero" => 2,                                 # Febrero
              "Februar" => 2,                                 # Februar
              "February" => 2,                                # February
              "F\xc9V" => 2,                                  # FV
              "F\xc9VRIER" => 2,                              # FVRIER
              "F\xe9v" => 2,                                  # Fv
              "F\xe9vrier" => 2,                              # Fvrier
              "feb" => 2,                                     # feb
              "febbraio" => 2,                                # febbraio
              "febrero" => 2,                                 # febrero
              "februar" => 2,                                 # februar
              "february" => 2,                                # february
              "f\xe9v" => 2,                                  # fv
              "f\xe9vrier" => 2,                              # fvrier
              "\x94\x85\x82" => 2,                            # 
              "\x94\x85\x82\x90\x80\x8b\x9c" => 2,            # 
              "\x94\x85\x82\x90\x80\x8b\x9f" => 2,            # 
              "\x94\xa5\xa2" => 2,                            # 
              "\x94\xa5\xa2\xe0\xa0\xab\xec" => 2,            # ࠫ
              "\x94\xa5\xa2\xe0\xa0\xab\xef" => 2,            # ࠫ
              "\xbb\xce\xc2" => 2,                            # 
              "\xbb\xce\xc2\xb8\xb9" => 2,                    # ¸
              "\xbb\xce\xc2\xbe\xb3\xbe" => 2,                # ¾
              "\xbb\xee\xe2" => 2,                            # 
              "\xbb\xee\xe2\xd8\xd9" => 2,                    # 
              "\xbb\xee\xe2\xde\xd3\xde" => 2,                # 
              "\xc4\xb5\xb2" => 2,                            # ĵ
              "\xc4\xb5\xb2\xc0\xb0\xbb\xcc" => 2,            # ĵ
              "\xc4\xb5\xb2\xc0\xb0\xbb\xcf" => 2,            # ĵ
              "\xc4\xd5\xd2" => 2,                            # 
              "\xc4\xd5\xd2\xe0\xd0\xdb\xec" => 2,            # 
              "\xc4\xd5\xd2\xe0\xd0\xdb\xef" => 2,            # 
              "\xc6\xc5\xd7" => 2,                            # 
              "\xc6\xc5\xd7\xd2\xc1\xcc\xd1" => 2,            # 
              "\xc6\xc5\xd7\xd2\xc1\xcc\xd8" => 2,            # 
              "\xcc\xc0\xd4" => 2,                            # 
              "\xcc\xc0\xd4\xc9\xca" => 2,                    # 
              "\xcc\xc0\xd4\xcf\xc7\xcf" => 2,                # 
              "\xd4\xc5\xc2" => 2,                            # 
              "\xd4\xc5\xc2\xd0\xc0\xcb\xdc" => 2,            # 
              "\xd4\xc5\xc2\xd0\xc0\xcb\xdf" => 2,            # 
              "\xd4\xe5\xe2" => 2,                            # 
              "\xd4\xe5\xe2\xf0\xe0\xeb\xfc" => 2,            # 
              "\xd4\xe5\xe2\xf0\xe0\xeb\xff" => 2,            # 
              "\xdb\xee\xe2" => 2,                            # 
              "\xdb\xee\xe2\xd8\xd9" => 2,                    # 
              "\xdb\xee\xe2\xde\xd3\xde" => 2,                # 
              "\xe4\xa5\xa2" => 2,                            # 䥢
              "\xe4\xa5\xa2\xe0\xa0\xab\xec" => 2,            # 䥢ࠫ
              "\xe4\xa5\xa2\xe0\xa0\xab\xef" => 2,            # 䥢ࠫ
              "\xe4\xd5\xd2" => 2,                            # 
              "\xe4\xd5\xd2\xe0\xd0\xdb\xec" => 2,            # 
              "\xe4\xd5\xd2\xe0\xd0\xdb\xef" => 2,            # 
              "\xe6\xc5\xd7" => 2,                            # 
              "\xe6\xc5\xd7\xd2\xc1\xcc\xd1" => 2,            # 
              "\xe6\xc5\xd7\xd2\xc1\xcc\xd8" => 2,            # 
              "\xe6\xe5\xf7" => 2,                            # 
              "\xe6\xe5\xf7\xf2\xe1\xec\xf1" => 2,            # 
              "\xe6\xe5\xf7\xf2\xe1\xec\xf8" => 2,            # 
              "\xec\xc0\xd4" => 2,                            # 
              "\xec\xc0\xd4\xc9\xca" => 2,                    # 
              "\xec\xc0\xd4\xcf\xc7\xcf" => 2,                # 
              "\xec\xe0\xf4" => 2,                            # 
              "\xec\xe0\xf4\xe9\xea" => 2,                    # 
              "\xec\xe0\xf4\xef\xe7\xef" => 2,                # 
              "\xf4\xe5\xe2" => 2,                            # 
              "\xf4\xe5\xe2\xf0\xe0\xeb\xfc" => 2,            # 
              "\xf4\xe5\xe2\xf0\xe0\xeb\xff" => 2,            # 
              "MAR" => 3,                                     # MAR
              "MARCH" => 3,                                   # MARCH
              "MARS" => 3,                                    # MARS
              "MARZO" => 3,                                   # MARZO
              "Mar" => 3,                                     # Mar
              "March" => 3,                                   # March
              "Mars" => 3,                                    # Mars
              "Marzo" => 3,                                   # Marzo
              "M\xc4R" => 3,                                  # MR
              "M\xc4RZ" => 3,                                 # MRZ
              "M\xe4r" => 3,                                  # Mr
              "M\xe4rz" => 3,                                 # Mrz
              "mar" => 3,                                     # mar
              "march" => 3,                                   # march
              "mars" => 3,                                    # mars
              "marzo" => 3,                                   # marzo
              "m\xe4r" => 3,                                  # mr
              "m\xe4rz" => 3,                                 # mrz
              "\x8c\x80\x90" => 3,                            # 
              "\x8c\x80\x90\x92" => 3,                        # 
              "\x8c\x80\x90\x92\x80" => 3,                    # 
              "\x8c\xa0\xe0" => 3,                            # 
              "\x8c\xa0\xe0\xe2" => 3,                        # 
              "\x8c\xa0\xe0\xe2\xa0" => 3,                    # 
              "\xac\xa0\xe0" => 3,                            # 
              "\xac\xa0\xe0\xe2" => 3,                        # 
              "\xac\xa0\xe0\xe2\xa0" => 3,                    # 
              "\xb1\xb5\xc0" => 3,                            # 
              "\xb1\xb5\xc0\xb5\xb7\xb5\xbd\xcc" => 3,        # 
              "\xb1\xb5\xc0\xb5\xb7\xbd\xcf" => 3,            # 
              "\xb1\xd5\xe0" => 3,                            # 
              "\xb1\xd5\xe0\xd5\xd7\xd5\xdd\xec" => 3,        # 
              "\xb1\xd5\xe0\xd5\xd7\xdd\xef" => 3,            # 
              "\xbc\xb0\xc0" => 3,                            # 
              "\xbc\xb0\xc0\xc2" => 3,                        # 
              "\xbc\xb0\xc0\xc2\xb0" => 3,                    # °
              "\xbc\xd0\xe0" => 3,                            # 
              "\xbc\xd0\xe0\xe2" => 3,                        # 
              "\xbc\xd0\xe0\xe2\xd0" => 3,                    # 
              "\xc2\xc5\xd2" => 3,                            # 
              "\xc2\xc5\xd2\xc5\xda\xc5\xce\xd8" => 3,        # 
              "\xc2\xc5\xd2\xc5\xda\xce\xd1" => 3,            # 
              "\xcc\xc0\xd0" => 3,                            # 
              "\xcc\xc0\xd0\xd2" => 3,                        # 
              "\xcc\xc0\xd0\xd2\xc0" => 3,                    # 
              "\xcc\xe0\xf0" => 3,                            # 
              "\xcc\xe0\xf0\xf2" => 3,                        # 
              "\xcc\xe0\xf0\xf2\xe0" => 3,                    # 
              "\xcd\xc1\xd2" => 3,                            # 
              "\xcd\xc1\xd2\xd4" => 3,                        # 
              "\xcd\xc1\xd2\xd4\xc1" => 3,                    # 
              "\xd1\xd5\xe0" => 3,                            # 
              "\xd1\xd5\xe0\xd5\xd7\xd5\xdd\xec" => 3,        # 
              "\xd1\xd5\xe0\xd5\xd7\xdd\xef" => 3,            # 
              "\xdc\xd0\xe0" => 3,                            # 
              "\xdc\xd0\xe0\xe2" => 3,                        # 
              "\xdc\xd0\xe0\xe2\xd0" => 3,                    # 
              "\xe2\xc5\xd2" => 3,                            # 
              "\xe2\xc5\xd2\xc5\xda\xc5\xce\xd8" => 3,        # 
              "\xe2\xc5\xd2\xc5\xda\xce\xd1" => 3,            # 
              "\xe2\xe5\xf2" => 3,                            # 
              "\xe2\xe5\xf2\xe5\xfa\xe5\xee\xf8" => 3,        # 
              "\xe2\xe5\xf2\xe5\xfa\xee\xf1" => 3,            # 
              "\xec\xe0\xf0" => 3,                            # 
              "\xec\xe0\xf0\xf2" => 3,                        # 
              "\xec\xe0\xf0\xf2\xe0" => 3,                    # 
              "\xed\xc1\xd2" => 3,                            # 
              "\xed\xc1\xd2\xd4" => 3,                        # 
              "\xed\xc1\xd2\xd4\xc1" => 3,                    # 
              "\xed\xe1\xf2" => 3,                            # 
              "\xed\xe1\xf2\xf4" => 3,                        # 
              "\xed\xe1\xf2\xf4\xe1" => 3,                    # 
              "ABR" => 4,                                     # ABR
              "ABRIL" => 4,                                   # ABRIL
              "APR" => 4,                                     # APR
              "APRIL" => 4,                                   # APRIL
              "APRILE" => 4,                                  # APRILE
              "AVR" => 4,                                     # AVR
              "AVRIL" => 4,                                   # AVRIL
              "Abr" => 4,                                     # Abr
              "Abril" => 4,                                   # Abril
              "Apr" => 4,                                     # Apr
              "April" => 4,                                   # April
              "Aprile" => 4,                                  # Aprile
              "Avr" => 4,                                     # Avr
              "Avril" => 4,                                   # Avril
              "abr" => 4,                                     # abr
              "abril" => 4,                                   # abril
              "apr" => 4,                                     # apr
              "april" => 4,                                   # april
              "aprile" => 4,                                  # aprile
              "avr" => 4,                                     # avr
              "avril" => 4,                                   # avril
              "\x80\x8f\x90" => 4,                            # 
              "\x80\x8f\x90\x85\x8b\x9c" => 4,                # 
              "\x80\x8f\x90\x85\x8b\x9f" => 4,                # 
              "\x80\xaf\xe0" => 4,                            # 
              "\x80\xaf\xe0\xa5\xab\xec" => 4,                # ५
              "\x80\xaf\xe0\xa5\xab\xef" => 4,                # ५
              "\xa0\xaf\xe0" => 4,                            # 
              "\xa0\xaf\xe0\xa5\xab\xec" => 4,                # ५
              "\xa0\xaf\xe0\xa5\xab\xef" => 4,                # ५
              "\xb0\xbf\xc0" => 4,                            # 
              "\xb0\xbf\xc0\xb5\xbb\xcc" => 4,                # 
              "\xb0\xbf\xc0\xb5\xbb\xcf" => 4,                # 
              "\xb0\xdf\xe0" => 4,                            # 
              "\xb0\xdf\xe0\xd5\xdb\xec" => 4,                # 
              "\xb0\xdf\xe0\xd5\xdb\xef" => 4,                # 
              "\xba\xb2\xa6" => 4,                            # 
              "\xba\xb2\xa6\xc2\xb5\xbd\xcc" => 4,            # µ
              "\xba\xb2\xa6\xc2\xbd\xcf" => 4,                # ½
              "\xba\xd2\xf6" => 4,                            # 
              "\xba\xd2\xf6\xe2\xd5\xdd\xec" => 4,            # 
              "\xba\xd2\xf6\xe2\xdd\xef" => 4,                # 
              "\xc0\xcf\xd0" => 4,                            # 
              "\xc0\xcf\xd0\xc5\xcb\xdc" => 4,                # 
              "\xc0\xcf\xd0\xc5\xcb\xdf" => 4,                # 
              "\xc0\xef\xf0" => 4,                            # 
              "\xc0\xef\xf0\xe5\xeb\xfc" => 4,                # 
              "\xc0\xef\xf0\xe5\xeb\xff" => 4,                # 
              "\xc1\xd0\xd2" => 4,                            # 
              "\xc1\xd0\xd2\xc5\xcc\xd1" => 4,                # 
              "\xc1\xd0\xd2\xc5\xcc\xd8" => 4,                # 
              "\xcb\xd7\xa6" => 4,                            # צ
              "\xcb\xd7\xa6\xd4\xc5\xce\xd8" => 4,            # צ
              "\xcb\xd7\xa6\xd4\xce\xd1" => 4,                # צ
              "\xd0\xdf\xe0" => 4,                            # 
              "\xd0\xdf\xe0\xd5\xdb\xec" => 4,                # 
              "\xd0\xdf\xe0\xd5\xdb\xef" => 4,                # 
              "\xda\xd2\xf6" => 4,                            # 
              "\xda\xd2\xf6\xe2\xd5\xdd\xec" => 4,            # 
              "\xda\xd2\xf6\xe2\xdd\xef" => 4,                # 
              "\xe0\xef\xf0" => 4,                            # 
              "\xe0\xef\xf0\xe5\xeb\xfc" => 4,                # 
              "\xe0\xef\xf0\xe5\xeb\xff" => 4,                # 
              "\xe1\xd0\xd2" => 4,                            # 
              "\xe1\xd0\xd2\xc5\xcc\xd1" => 4,                # 
              "\xe1\xd0\xd2\xc5\xcc\xd8" => 4,                # 
              "\xe1\xf0\xf2" => 4,                            # 
              "\xe1\xf0\xf2\xe5\xec\xf1" => 4,                # 
              "\xe1\xf0\xf2\xe5\xec\xf8" => 4,                # 
              "\xeb\xd7\xa6" => 4,                            # צ
              "\xeb\xd7\xa6\xd4\xc5\xce\xd8" => 4,            # צ
              "\xeb\xd7\xa6\xd4\xce\xd1" => 4,                # צ
              "\xeb\xf7\xb6" => 4,                            # 
              "\xeb\xf7\xb6\xf4\xe5\xee\xf8" => 4,            # 
              "\xeb\xf7\xb6\xf4\xee\xf1" => 4,                # 
              "MAG" => 5,                                     # MAG
              "MAGGIO" => 5,                                  # MAGGIO
              "MAI" => 5,                                     # MAI
              "MAY" => 5,                                     # MAY
              "MAYO" => 5,                                    # MAYO
              "Mag" => 5,                                     # Mag
              "Maggio" => 5,                                  # Maggio
              "Mai" => 5,                                     # Mai
              "May" => 5,                                     # May
              "Mayo" => 5,                                    # Mayo
              "mag" => 5,                                     # mag
              "maggio" => 5,                                  # maggio
              "mai" => 5,                                     # mai
              "may" => 5,                                     # may
              "mayo" => 5,                                    # mayo
              "\x8c\x80\x89" => 5,                            # 
              "\x8c\x80\x9f" => 5,                            # 
              "\x8c\xa0\xa9" => 5,                            # 
              "\x8c\xa0\xef" => 5,                            # 
              "\xac\xa0\xa9" => 5,                            # 
              "\xac\xa0\xef" => 5,                            # 
              "\xbc\xb0\xb9" => 5,                            # 
              "\xbc\xb0\xcf" => 5,                            # 
              "\xbc\xd0\xd9" => 5,                            # 
              "\xbc\xd0\xef" => 5,                            # 
              "\xc2\xc0\xb0" => 5,                            # 
              "\xc2\xc0\xb0\xb2\xb5\xbd\xcc" => 5,            # 
              "\xc2\xc0\xb0\xb2\xbd\xcf" => 5,                # 
              "\xc2\xe0\xd0" => 5,                            # 
              "\xc2\xe0\xd0\xd2\xd5\xdd\xec" => 5,            # 
              "\xc2\xe0\xd0\xd2\xdd\xef" => 5,                # 
              "\xcc\xc0\xc9" => 5,                            # 
              "\xcc\xc0\xdf" => 5,                            # 
              "\xcc\xe0\xe9" => 5,                            # 
              "\xcc\xe0\xff" => 5,                            # 
              "\xcd\xc1\xca" => 5,                            # 
              "\xcd\xc1\xd1" => 5,                            # 
              "\xd4\xd2\xc1" => 5,                            # 
              "\xd4\xd2\xc1\xd7\xc5\xce\xd8" => 5,            # 
              "\xd4\xd2\xc1\xd7\xce\xd1" => 5,                # 
              "\xdc\xd0\xd9" => 5,                            # 
              "\xdc\xd0\xef" => 5,                            # 
              "\xe2\xe0\xd0" => 5,                            # 
              "\xe2\xe0\xd0\xd2\xd5\xdd\xec" => 5,            # 
              "\xe2\xe0\xd0\xd2\xdd\xef" => 5,                # 
              "\xec\xe0\xe9" => 5,                            # 
              "\xec\xe0\xff" => 5,                            # 
              "\xed\xc1\xca" => 5,                            # 
              "\xed\xc1\xd1" => 5,                            # 
              "\xed\xe1\xea" => 5,                            # 
              "\xed\xe1\xf1" => 5,                            # 
              "\xf4\xd2\xc1" => 5,                            # 
              "\xf4\xd2\xc1\xd7\xc5\xce\xd8" => 5,            # 
              "\xf4\xd2\xc1\xd7\xce\xd1" => 5,                # 
              "\xf4\xf2\xe1" => 5,                            # 
              "\xf4\xf2\xe1\xf7\xe5\xee\xf8" => 5,            # 
              "\xf4\xf2\xe1\xf7\xee\xf1" => 5,                # 
              "GIU" => 6,                                     # GIU
              "GIUGNO" => 6,                                  # GIUGNO
              "Giu" => 6,                                     # Giu
              "Giugno" => 6,                                  # Giugno
              "JUI" => 6,                                     # JUI
              "JUIN" => 6,                                    # JUIN
              "JUN" => 6,                                     # JUN
              "JUNE" => 6,                                    # JUNE
              "JUNI" => 6,                                    # JUNI
              "JUNIO" => 6,                                   # JUNIO
              "Jui" => 6,                                     # Jui
              "Juin" => 6,                                    # Juin
              "Jun" => 6,                                     # Jun
              "June" => 6,                                    # June
              "Juni" => 6,                                    # Juni
              "Junio" => 6,                                   # Junio
              "giu" => 6,                                     # giu
              "giugno" => 6,                                  # giugno
              "jui" => 6,                                     # jui
              "juin" => 6,                                    # juin
              "jun" => 6,                                     # jun
              "june" => 6,                                    # june
              "juni" => 6,                                    # juni
              "junio" => 6,                                   # junio
              "\x88\x9e\x8d" => 6,                            # 
              "\x88\x9e\x8d\x9c" => 6,                        # 
              "\x88\x9e\x8d\x9f" => 6,                        # 
              "\x88\xee\xad" => 6,                            # 
              "\x88\xee\xad\xec" => 6,                        # 
              "\x88\xee\xad\xef" => 6,                        # 
              "\xa8\xee\xad" => 6,                            # 
              "\xa8\xee\xad\xec" => 6,                        # 
              "\xa8\xee\xad\xef" => 6,                        # 
              "\xb8\xce\xbd" => 6,                            # ν
              "\xb8\xce\xbd\xcc" => 6,                        # ν
              "\xb8\xce\xbd\xcf" => 6,                        # ν
              "\xb8\xee\xdd" => 6,                            # 
              "\xb8\xee\xdd\xec" => 6,                        # 
              "\xb8\xee\xdd\xef" => 6,                        # 
              "\xc7\xb5\xc0" => 6,                            # ǵ
              "\xc7\xb5\xc0\xb2\xb5\xbd\xcc" => 6,            # ǵ
              "\xc7\xb5\xc0\xb2\xbd\xcf" => 6,                # ǵ
              "\xc7\xd5\xe0" => 6,                            # 
              "\xc7\xd5\xe0\xd2\xd5\xdd\xec" => 6,            # 
              "\xc7\xd5\xe0\xd2\xdd\xef" => 6,                # 
              "\xc8\xde\xcd" => 6,                            # 
              "\xc8\xde\xcd\xdc" => 6,                        # 
              "\xc8\xde\xcd\xdf" => 6,                        # 
              "\xc8\xfe\xed" => 6,                            # 
              "\xc8\xfe\xed\xfc" => 6,                        # 
              "\xc8\xfe\xed\xff" => 6,                        # 
              "\xc9\xc0\xce" => 6,                            # 
              "\xc9\xc0\xce\xd1" => 6,                        # 
              "\xc9\xc0\xce\xd8" => 6,                        # 
              "\xd8\xee\xdd" => 6,                            # 
              "\xd8\xee\xdd\xec" => 6,                        # 
              "\xd8\xee\xdd\xef" => 6,                        # 
              "\xde\xc5\xd2" => 6,                            # 
              "\xde\xc5\xd2\xd7\xc5\xce\xd8" => 6,            # 
              "\xde\xc5\xd2\xd7\xce\xd1" => 6,                # 
              "\xe7\xd5\xe0" => 6,                            # 
              "\xe7\xd5\xe0\xd2\xd5\xdd\xec" => 6,            # 
              "\xe7\xd5\xe0\xd2\xdd\xef" => 6,                # 
              "\xe8\xfe\xed" => 6,                            # 
              "\xe8\xfe\xed\xfc" => 6,                        # 
              "\xe8\xfe\xed\xff" => 6,                        # 
              "\xe9\xc0\xce" => 6,                            # 
              "\xe9\xc0\xce\xd1" => 6,                        # 
              "\xe9\xc0\xce\xd8" => 6,                        # 
              "\xe9\xe0\xee" => 6,                            # 
              "\xe9\xe0\xee\xf1" => 6,                        # 
              "\xe9\xe0\xee\xf8" => 6,                        # 
              "\xfe\xc5\xd2" => 6,                            # 
              "\xfe\xc5\xd2\xd7\xc5\xce\xd8" => 6,            # 
              "\xfe\xc5\xd2\xd7\xce\xd1" => 6,                # 
              "\xfe\xe5\xf2" => 6,                            # 
              "\xfe\xe5\xf2\xf7\xe5\xee\xf8" => 6,            # 
              "\xfe\xe5\xf2\xf7\xee\xf1" => 6,                # 
              "JUILLET" => 7,                                 # JUILLET
              "JUL" => 7,                                     # JUL
              "JULI" => 7,                                    # JULI
              "JULIO" => 7,                                   # JULIO
              "JULY" => 7,                                    # JULY
              "Juillet" => 7,                                 # Juillet
              "Jul" => 7,                                     # Jul
              "Juli" => 7,                                    # Juli
              "Julio" => 7,                                   # Julio
              "July" => 7,                                    # July
              "LUG" => 7,                                     # LUG
              "LUGLIO" => 7,                                  # LUGLIO
              "Lug" => 7,                                     # Lug
              "Luglio" => 7,                                  # Luglio
              "juillet" => 7,                                 # juillet
              "jul" => 7,                                     # jul
              "juli" => 7,                                    # juli
              "julio" => 7,                                   # julio
              "july" => 7,                                    # july
              "lug" => 7,                                     # lug
              "luglio" => 7,                                  # luglio
              "\x88\x9e\x8b" => 7,                            # 
              "\x88\x9e\x8b\x9c" => 7,                        # 
              "\x88\x9e\x8b\x9f" => 7,                        # 
              "\x88\xee\xab" => 7,                            # 
              "\x88\xee\xab\xec" => 7,                        # 
              "\x88\xee\xab\xef" => 7,                        # 
              "\xa8\xee\xab" => 7,                            # 
              "\xa8\xee\xab\xec" => 7,                        # 
              "\xa8\xee\xab\xef" => 7,                        # 
              "\xb8\xce\xbb" => 7,                            # λ
              "\xb8\xce\xbb\xcc" => 7,                        # λ
              "\xb8\xce\xbb\xcf" => 7,                        # λ
              "\xb8\xee\xdb" => 7,                            # 
              "\xb8\xee\xdb\xec" => 7,                        # 
              "\xb8\xee\xdb\xef" => 7,                        # 
              "\xbb\xb8\xbf" => 7,                            # 
              "\xbb\xb8\xbf\xb5\xbd\xcc" => 7,                # 
              "\xbb\xb8\xbf\xbd\xcf" => 7,                    # 
              "\xbb\xd8\xdf" => 7,                            # 
              "\xbb\xd8\xdf\xd5\xdd\xec" => 7,                # 
              "\xbb\xd8\xdf\xdd\xef" => 7,                    # 
              "\xc8\xde\xcb" => 7,                            # 
              "\xc8\xde\xcb\xdc" => 7,                        # 
              "\xc8\xde\xcb\xdf" => 7,                        # 
              "\xc8\xfe\xeb" => 7,                            # 
              "\xc8\xfe\xeb\xfc" => 7,                        # 
              "\xc8\xfe\xeb\xff" => 7,                        # 
              "\xc9\xc0\xcc" => 7,                            # 
              "\xc9\xc0\xcc\xd1" => 7,                        # 
              "\xc9\xc0\xcc\xd8" => 7,                        # 
              "\xcc\xc9\xd0" => 7,                            # 
              "\xcc\xc9\xd0\xc5\xce\xd8" => 7,                # 
              "\xcc\xc9\xd0\xce\xd1" => 7,                    # 
              "\xd8\xee\xdb" => 7,                            # 
              "\xd8\xee\xdb\xec" => 7,                        # 
              "\xd8\xee\xdb\xef" => 7,                        # 
              "\xdb\xd8\xdf" => 7,                            # 
              "\xdb\xd8\xdf\xd5\xdd\xec" => 7,                # 
              "\xdb\xd8\xdf\xdd\xef" => 7,                    # 
              "\xe8\xfe\xeb" => 7,                            # 
              "\xe8\xfe\xeb\xfc" => 7,                        # 
              "\xe8\xfe\xeb\xff" => 7,                        # 
              "\xe9\xc0\xcc" => 7,                            # 
              "\xe9\xc0\xcc\xd1" => 7,                        # 
              "\xe9\xc0\xcc\xd8" => 7,                        # 
              "\xe9\xe0\xec" => 7,                            # 
              "\xe9\xe0\xec\xf1" => 7,                        # 
              "\xe9\xe0\xec\xf8" => 7,                        # 
              "\xec\xc9\xd0" => 7,                            # 
              "\xec\xc9\xd0\xc5\xce\xd8" => 7,                # 
              "\xec\xc9\xd0\xce\xd1" => 7,                    # 
              "\xec\xe9\xf0" => 7,                            # 
              "\xec\xe9\xf0\xe5\xee\xf8" => 7,                # 
              "\xec\xe9\xf0\xee\xf1" => 7,                    # 
              "AGO" => 8,                                     # AGO
              "AGOSTO" => 8,                                  # AGOSTO
              "AO\xdb" => 8,                                  # AO
              "AO\xdbT" => 8,                                 # AOT
              "AUG" => 8,                                     # AUG
              "AUGUST" => 8,                                  # AUGUST
              "Ago" => 8,                                     # Ago
              "Agosto" => 8,                                  # Agosto
              "Ao\xfb" => 8,                                  # Ao
              "Ao\xfbt" => 8,                                 # Aot
              "Aug" => 8,                                     # Aug
              "August" => 8,                                  # August
              "ago" => 8,                                     # ago
              "agosto" => 8,                                  # agosto
              "ao\xfb" => 8,                                  # ao
              "ao\xfbt" => 8,                                 # aot
              "aug" => 8,                                     # aug
              "august" => 8,                                  # august
              "\x80\x82\x83" => 8,                            # 
              "\x80\x82\x83\x93\x91\x92" => 8,                # 
              "\x80\x82\x83\x93\x91\x92\x80" => 8,            # 
              "\x80\xa2\xa3" => 8,                            # 
              "\x80\xa2\xa3\xe3\xe1\xe2" => 8,                # 
              "\x80\xa2\xa3\xe3\xe1\xe2\xa0" => 8,            # 
              "\xa0\xa2\xa3" => 8,                            # 
              "\xa0\xa2\xa3\xe3\xe1\xe2" => 8,                # 
              "\xa0\xa2\xa3\xe3\xe1\xe2\xa0" => 8,            # 
              "\xb0\xb2\xb3" => 8,                            # 
              "\xb0\xb2\xb3\xc3\xc1\xc2" => 8,                # 
              "\xb0\xb2\xb3\xc3\xc1\xc2\xb0" => 8,            # °
              "\xb0\xd2\xd3" => 8,                            # 
              "\xb0\xd2\xd3\xe3\xe1\xe2" => 8,                # 
              "\xb0\xd2\xd3\xe3\xe1\xe2\xd0" => 8,            # 
              "\xc0\xc2\xc3" => 8,                            # 
              "\xc0\xc2\xc3\xd3\xd1\xd2" => 8,                # 
              "\xc0\xc2\xc3\xd3\xd1\xd2\xc0" => 8,            # 
              "\xc0\xe2\xe3" => 8,                            # 
              "\xc0\xe2\xe3\xf3\xf1\xf2" => 8,                # 
              "\xc0\xe2\xe3\xf3\xf1\xf2\xe0" => 8,            # 
              "\xc1\xb5\xc0" => 8,                            # 
              "\xc1\xb5\xc0\xbf\xb5\xbd\xcc" => 8,            # 
              "\xc1\xb5\xc0\xbf\xbd\xcf" => 8,                # 
              "\xc1\xd5\xe0" => 8,                            # 
              "\xc1\xd5\xe0\xdf\xd5\xdd\xec" => 8,            # 
              "\xc1\xd5\xe0\xdf\xdd\xef" => 8,                # 
              "\xc1\xd7\xc7" => 8,                            # 
              "\xc1\xd7\xc7\xd5\xd3\xd4" => 8,                # 
              "\xc1\xd7\xc7\xd5\xd3\xd4\xc1" => 8,            # 
              "\xd0\xd2\xd3" => 8,                            # 
              "\xd0\xd2\xd3\xe3\xe1\xe2" => 8,                # 
              "\xd0\xd2\xd3\xe3\xe1\xe2\xd0" => 8,            # 
              "\xd3\xc5\xd2" => 8,                            # 
              "\xd3\xc5\xd2\xd0\xc5\xce\xd8" => 8,            # 
              "\xd3\xc5\xd2\xd0\xce\xd1" => 8,                # 
              "\xe0\xe2\xe3" => 8,                            # 
              "\xe0\xe2\xe3\xf3\xf1\xf2" => 8,                # 
              "\xe0\xe2\xe3\xf3\xf1\xf2\xe0" => 8,            # 
              "\xe1\xd5\xe0" => 8,                            # 
              "\xe1\xd5\xe0\xdf\xd5\xdd\xec" => 8,            # 
              "\xe1\xd5\xe0\xdf\xdd\xef" => 8,                # 
              "\xe1\xd7\xc7" => 8,                            # 
              "\xe1\xd7\xc7\xd5\xd3\xd4" => 8,                # 
              "\xe1\xd7\xc7\xd5\xd3\xd4\xc1" => 8,            # 
              "\xe1\xf7\xe7" => 8,                            # 
              "\xe1\xf7\xe7\xf5\xf3\xf4" => 8,                # 
              "\xe1\xf7\xe7\xf5\xf3\xf4\xe1" => 8,            # 
              "\xf3\xc5\xd2" => 8,                            # 
              "\xf3\xc5\xd2\xd0\xc5\xce\xd8" => 8,            # 
              "\xf3\xc5\xd2\xd0\xce\xd1" => 8,                # 
              "\xf3\xe5\xf2" => 8,                            # 
              "\xf3\xe5\xf2\xf0\xe5\xee\xf8" => 8,            # 
              "\xf3\xe5\xf2\xf0\xee\xf1" => 8,                # 
              "SEP" => 9,                                     # SEP
              "SEPTEMBER" => 9,                               # SEPTEMBER
              "SEPTEMBRE" => 9,                               # SEPTEMBRE
              "SEPTIEMBRE" => 9,                              # SEPTIEMBRE
              "SET" => 9,                                     # SET
              "SETTEMBRE" => 9,                               # SETTEMBRE
              "Sep" => 9,                                     # Sep
              "September" => 9,                               # September
              "Septembre" => 9,                               # Septembre
              "Septiembre" => 9,                              # Septiembre
              "Set" => 9,                                     # Set
              "Settembre" => 9,                               # Settembre
              "sep" => 9,                                     # sep
              "september" => 9,                               # september
              "septembre" => 9,                               # septembre
              "septiembre" => 9,                              # septiembre
              "set" => 9,                                     # set
              "settembre" => 9,                               # settembre
              "\x91\x85\x8d" => 9,                            # 
              "\x91\x85\x8d\x92\x9f\x81\x90\x9c" => 9,        # 
              "\x91\x85\x8d\x92\x9f\x81\x90\x9f" => 9,        # 
              "\x91\xa5\xad" => 9,                            # 
              "\x91\xa5\xad\xe2\xef\xa1\xe0\xec" => 9,        # 
              "\x91\xa5\xad\xe2\xef\xa1\xe0\xef" => 9,        # 
              "\xb2\xb5\xc0" => 9,                            # 
              "\xb2\xb5\xc0\xb5\xc1\xb5\xbd\xcc" => 9,        # 
              "\xb2\xb5\xc0\xb5\xc1\xbd\xcf" => 9,            # 
              "\xb2\xd5\xe0" => 9,                            # 
              "\xb2\xd5\xe0\xd5\xe1\xd5\xdd\xec" => 9,        # 
              "\xb2\xd5\xe0\xd5\xe1\xdd\xef" => 9,            # 
              "\xc1\xb5\xbd" => 9,                            # 
              "\xc1\xb5\xbd\xc2\xcf\xb1\xc0\xcc" => 9,        # ϱ
              "\xc1\xb5\xbd\xc2\xcf\xb1\xc0\xcf" => 9,        # ϱ
              "\xc1\xd5\xdd" => 9,                            # 
              "\xc1\xd5\xdd\xe2\xef\xd1\xe0\xec" => 9,        # 
              "\xc1\xd5\xdd\xe2\xef\xd1\xe0\xef" => 9,        # 
              "\xd1\xc5\xcd" => 9,                            # 
              "\xd1\xc5\xcd\xd2\xdf\xc1\xd0\xdc" => 9,        # 
              "\xd1\xc5\xcd\xd2\xdf\xc1\xd0\xdf" => 9,        # 
              "\xd1\xe5\xed" => 9,                            # 
              "\xd1\xe5\xed\xf2\xff\xe1\xf0\xfc" => 9,        # 
              "\xd1\xe5\xed\xf2\xff\xe1\xf0\xff" => 9,        # 
              "\xd2\xd5\xe0" => 9,                            # 
              "\xd2\xd5\xe0\xd5\xe1\xd5\xdd\xec" => 9,        # 
              "\xd2\xd5\xe0\xd5\xe1\xdd\xef" => 9,            # 
              "\xd3\xc5\xce" => 9,                            # 
              "\xd3\xc5\xce\xd4\xd1\xc2\xd2\xd1" => 9,        # 
              "\xd3\xc5\xce\xd4\xd1\xc2\xd2\xd8" => 9,        # 
              "\xd7\xc5\xd2" => 9,                            # 
              "\xd7\xc5\xd2\xc5\xd3\xc5\xce\xd8" => 9,        # 
              "\xd7\xc5\xd2\xc5\xd3\xce\xd1" => 9,            # 
              "\xe1\xa5\xad" => 9,                            # ᥭ
              "\xe1\xa5\xad\xe2\xef\xa1\xe0\xec" => 9,        # ᥭ
              "\xe1\xa5\xad\xe2\xef\xa1\xe0\xef" => 9,        # ᥭ
              "\xe1\xd5\xdd" => 9,                            # 
              "\xe1\xd5\xdd\xe2\xef\xd1\xe0\xec" => 9,        # 
              "\xe1\xd5\xdd\xe2\xef\xd1\xe0\xef" => 9,        # 
              "\xf1\xe5\xed" => 9,                            # 
              "\xf1\xe5\xed\xf2\xff\xe1\xf0\xfc" => 9,        # 
              "\xf1\xe5\xed\xf2\xff\xe1\xf0\xff" => 9,        # 
              "\xf3\xc5\xce" => 9,                            # 
              "\xf3\xc5\xce\xd4\xd1\xc2\xd2\xd1" => 9,        # 
              "\xf3\xc5\xce\xd4\xd1\xc2\xd2\xd8" => 9,        # 
              "\xf3\xe5\xee" => 9,                            # 
              "\xf3\xe5\xee\xf4\xf1\xe2\xf2\xf1" => 9,        # 
              "\xf3\xe5\xee\xf4\xf1\xe2\xf2\xf8" => 9,        # 
              "\xf7\xc5\xd2" => 9,                            # 
              "\xf7\xc5\xd2\xc5\xd3\xc5\xce\xd8" => 9,        # 
              "\xf7\xc5\xd2\xc5\xd3\xce\xd1" => 9,            # 
              "\xf7\xe5\xf2" => 9,                            # 
              "\xf7\xe5\xf2\xe5\xf3\xe5\xee\xf8" => 9,        # 
              "\xf7\xe5\xf2\xe5\xf3\xee\xf1" => 9,            # 
              "OCT" => 10,                                     # OCT
              "OCTOBER" => 10,                                 # OCTOBER
              "OCTOBRE" => 10,                                 # OCTOBRE
              "OCTUBRE" => 10,                                 # OCTUBRE
              "OKT" => 10,                                     # OKT
              "OKTOBER" => 10,                                 # OKTOBER
              "OTT" => 10,                                     # OTT
              "OTTOBRE" => 10,                                 # OTTOBRE
              "Oct" => 10,                                     # Oct
              "October" => 10,                                 # October
              "Octobre" => 10,                                 # Octobre
              "Octubre" => 10,                                 # Octubre
              "Okt" => 10,                                     # Okt
              "Oktober" => 10,                                 # Oktober
              "Ott" => 10,                                     # Ott
              "Ottobre" => 10,                                 # Ottobre
              "oct" => 10,                                     # oct
              "october" => 10,                                 # october
              "octobre" => 10,                                 # octobre
              "octubre" => 10,                                 # octubre
              "okt" => 10,                                     # okt
              "oktober" => 10,                                 # oktober
              "ott" => 10,                                     # ott
              "ottobre" => 10,                                 # ottobre
              "\x8e\x8a\x92" => 10,                            # 
              "\x8e\x8a\x92\x9f\x81\x90\x9c" => 10,            # 
              "\x8e\x8a\x92\x9f\x81\x90\x9f" => 10,            # 
              "\x8e\xaa\xe2" => 10,                            # 
              "\x8e\xaa\xe2\xef\xa1\xe0\xec" => 10,            # 
              "\x8e\xaa\xe2\xef\xa1\xe0\xef" => 10,            # 
              "\xae\xaa\xe2" => 10,                            # 
              "\xae\xaa\xe2\xef\xa1\xe0\xec" => 10,            # 
              "\xae\xaa\xe2\xef\xa1\xe0\xef" => 10,            # 
              "\xb6\xbe\xb2" => 10,                            # 
              "\xb6\xbe\xb2\xc2\xb5\xbd\xcc" => 10,            # µ
              "\xb6\xbe\xb2\xc2\xbd\xcf" => 10,                # ½
              "\xb6\xde\xd2" => 10,                            # 
              "\xb6\xde\xd2\xe2\xd5\xdd\xec" => 10,            # 
              "\xb6\xde\xd2\xe2\xdd\xef" => 10,                # 
              "\xbe\xba\xc2" => 10,                            # 
              "\xbe\xba\xc2\xcf\xb1\xc0\xcc" => 10,            # ϱ
              "\xbe\xba\xc2\xcf\xb1\xc0\xcf" => 10,            # ϱ
              "\xbe\xda\xe2" => 10,                            # 
              "\xbe\xda\xe2\xef\xd1\xe0\xec" => 10,            # 
              "\xbe\xda\xe2\xef\xd1\xe0\xef" => 10,            # 
              "\xce\xca\xd2" => 10,                            # 
              "\xce\xca\xd2\xdf\xc1\xd0\xdc" => 10,            # 
              "\xce\xca\xd2\xdf\xc1\xd0\xdf" => 10,            # 
              "\xce\xea\xf2" => 10,                            # 
              "\xce\xea\xf2\xff\xe1\xf0\xfc" => 10,            # 
              "\xce\xea\xf2\xff\xe1\xf0\xff" => 10,            # 
              "\xcf\xcb\xd4" => 10,                            # 
              "\xcf\xcb\xd4\xd1\xc2\xd2\xd1" => 10,            # 
              "\xcf\xcb\xd4\xd1\xc2\xd2\xd8" => 10,            # 
              "\xd6\xcf\xd7" => 10,                            # 
              "\xd6\xcf\xd7\xd4\xc5\xce\xd8" => 10,            # 
              "\xd6\xcf\xd7\xd4\xce\xd1" => 10,                # 
              "\xd6\xde\xd2" => 10,                            # 
              "\xd6\xde\xd2\xe2\xd5\xdd\xec" => 10,            # 
              "\xd6\xde\xd2\xe2\xdd\xef" => 10,                # 
              "\xde\xda\xe2" => 10,                            # 
              "\xde\xda\xe2\xef\xd1\xe0\xec" => 10,            # 
              "\xde\xda\xe2\xef\xd1\xe0\xef" => 10,            # 
              "\xee\xea\xf2" => 10,                            # 
              "\xee\xea\xf2\xff\xe1\xf0\xfc" => 10,            # 
              "\xee\xea\xf2\xff\xe1\xf0\xff" => 10,            # 
              "\xef\xcb\xd4" => 10,                            # 
              "\xef\xcb\xd4\xd1\xc2\xd2\xd1" => 10,            # 
              "\xef\xcb\xd4\xd1\xc2\xd2\xd8" => 10,            # 
              "\xef\xeb\xf4" => 10,                            # 
              "\xef\xeb\xf4\xf1\xe2\xf2\xf1" => 10,            # 
              "\xef\xeb\xf4\xf1\xe2\xf2\xf8" => 10,            # 
              "\xf6\xcf\xd7" => 10,                            # 
              "\xf6\xcf\xd7\xd4\xc5\xce\xd8" => 10,            # 
              "\xf6\xcf\xd7\xd4\xce\xd1" => 10,                # 
              "\xf6\xef\xf7" => 10,                            # 
              "\xf6\xef\xf7\xf4\xe5\xee\xf8" => 10,            # 
              "\xf6\xef\xf7\xf4\xee\xf1" => 10,                # 
              "NOV" => 11,                                     # NOV
              "NOVEMBER" => 11,                                # NOVEMBER
              "NOVEMBRE" => 11,                                # NOVEMBRE
              "NOVIEMBRE" => 11,                               # NOVIEMBRE
              "Nov" => 11,                                     # Nov
              "November" => 11,                                # November
              "Novembre" => 11,                                # Novembre
              "Noviembre" => 11,                               # Noviembre
              "nov" => 11,                                     # nov
              "november" => 11,                                # november
              "novembre" => 11,                                # novembre
              "noviembre" => 11,                               # noviembre
              "\x8d\x8e\x9f" => 11,                            # 
              "\x8d\x8e\x9f\x81\x90\x9c" => 11,                # 
              "\x8d\x8e\x9f\x81\x90\x9f" => 11,                # 
              "\x8d\xae\xef" => 11,                            # 
              "\x8d\xae\xef\xa1\xe0\xec" => 11,                # 
              "\x8d\xae\xef\xa1\xe0\xef" => 11,                # 
              "\xad\xae\xef" => 11,                            # 
              "\xad\xae\xef\xa1\xe0\xec" => 11,                # 
              "\xad\xae\xef\xa1\xe0\xef" => 11,                # 
              "\xbb\xb8\xc1" => 11,                            # 
              "\xbb\xb8\xc1\xc2\xbe\xbf\xb0\xb4" => 11,        # ¾
              "\xbb\xb8\xc1\xc2\xbe\xbf\xb0\xb4\xb0" => 11,    # ¾
              "\xbb\xd8\xe1" => 11,                            # 
              "\xbb\xd8\xe1\xe2\xde\xdf\xd0\xd4" => 11,        # 
              "\xbb\xd8\xe1\xe2\xde\xdf\xd0\xd4\xd0" => 11,    # 
              "\xbd\xbe\xcf" => 11,                            # 
              "\xbd\xbe\xcf\xb1\xc0\xcc" => 11,                # ϱ
              "\xbd\xbe\xcf\xb1\xc0\xcf" => 11,                # ϱ
              "\xbd\xde\xef" => 11,                            # 
              "\xbd\xde\xef\xd1\xe0\xec" => 11,                # 
              "\xbd\xde\xef\xd1\xe0\xef" => 11,                # 
              "\xcc\xc9\xd3" => 11,                            # 
              "\xcc\xc9\xd3\xd4\xcf\xd0\xc1\xc4" => 11,        # 
              "\xcc\xc9\xd3\xd4\xcf\xd0\xc1\xc4\xc1" => 11,    # 
              "\xcd\xce\xdf" => 11,                            # 
              "\xcd\xce\xdf\xc1\xd0\xdc" => 11,                # 
              "\xcd\xce\xdf\xc1\xd0\xdf" => 11,                # 
              "\xcd\xee\xff" => 11,                            # 
              "\xcd\xee\xff\xe1\xf0\xfc" => 11,                # 
              "\xcd\xee\xff\xe1\xf0\xff" => 11,                # 
              "\xce\xcf\xd1" => 11,                            # 
              "\xce\xcf\xd1\xc2\xd2\xd1" => 11,                # 
              "\xce\xcf\xd1\xc2\xd2\xd8" => 11,                # 
              "\xdb\xd8\xe1" => 11,                            # 
              "\xdb\xd8\xe1\xe2\xde\xdf\xd0\xd4" => 11,        # 
              "\xdb\xd8\xe1\xe2\xde\xdf\xd0\xd4\xd0" => 11,    # 
              "\xdd\xde\xef" => 11,                            # 
              "\xdd\xde\xef\xd1\xe0\xec" => 11,                # 
              "\xdd\xde\xef\xd1\xe0\xef" => 11,                # 
              "\xec\xc9\xd3" => 11,                            # 
              "\xec\xc9\xd3\xd4\xcf\xd0\xc1\xc4" => 11,        # 
              "\xec\xc9\xd3\xd4\xcf\xd0\xc1\xc4\xc1" => 11,    # 
              "\xec\xe9\xf3" => 11,                            # 
              "\xec\xe9\xf3\xf4\xef\xf0\xe1\xe4" => 11,        # 
              "\xec\xe9\xf3\xf4\xef\xf0\xe1\xe4\xe1" => 11,    # 
              "\xed\xee\xff" => 11,                            # 
              "\xed\xee\xff\xe1\xf0\xfc" => 11,                # 
              "\xed\xee\xff\xe1\xf0\xff" => 11,                # 
              "\xee\xcf\xd1" => 11,                            # 
              "\xee\xcf\xd1\xc2\xd2\xd1" => 11,                # 
              "\xee\xcf\xd1\xc2\xd2\xd8" => 11,                # 
              "\xee\xef\xf1" => 11,                            # 
              "\xee\xef\xf1\xe2\xf2\xf1" => 11,                # 
              "\xee\xef\xf1\xe2\xf2\xf8" => 11,                # 
              "DEC" => 12,                                     # DEC
              "DECEMBER" => 12,                                # DECEMBER
              "DEZ" => 12,                                     # DEZ
              "DEZEMBER" => 12,                                # DEZEMBER
              "DIC" => 12,                                     # DIC
              "DICEMBRE" => 12,                                # DICEMBRE
              "DICIEMBRE" => 12,                               # DICIEMBRE
              "Dec" => 12,                                     # Dec
              "December" => 12,                                # December
              "Dez" => 12,                                     # Dez
              "Dezember" => 12,                                # Dezember
              "Dic" => 12,                                     # Dic
              "Dicembre" => 12,                                # Dicembre
              "Diciembre" => 12,                               # Diciembre
              "D\xc9C" => 12,                                  # DC
              "D\xc9CEMBRE" => 12,                             # DCEMBRE
              "D\xe9c" => 12,                                  # Dc
              "D\xe9cembre" => 12,                             # Dcembre
              "dec" => 12,                                     # dec
              "december" => 12,                                # december
              "dez" => 12,                                     # dez
              "dezember" => 12,                                # dezember
              "dic" => 12,                                     # dic
              "dicembre" => 12,                                # dicembre
              "diciembre" => 12,                               # diciembre
              "d\xe9c" => 12,                                  # dc
              "d\xe9cembre" => 12,                             # dcembre
              "\x84\x85\x8a" => 12,                            # 
              "\x84\x85\x8a\x80\x81\x90\x9c" => 12,            # 
              "\x84\x85\x8a\x80\x81\x90\x9f" => 12,            # 
              "\x84\xa5\xaa" => 12,                            # 
              "\x84\xa5\xaa\xa0\xa1\xe0\xec" => 12,            # 
              "\x84\xa5\xaa\xa0\xa1\xe0\xef" => 12,            # 
              "\xa4\xa5\xaa" => 12,                            # 
              "\xa4\xa5\xaa\xa0\xa1\xe0\xec" => 12,            # 
              "\xa4\xa5\xaa\xa0\xa1\xe0\xef" => 12,            # 
              "\xb3\xc0\xc3" => 12,                            # 
              "\xb3\xc0\xc3\xb4\xb5\xbd\xcc" => 12,            # ô
              "\xb3\xc0\xc3\xb4\xbd\xcf" => 12,                # ô
              "\xb3\xe0\xe3" => 12,                            # 
              "\xb3\xe0\xe3\xd4\xd5\xdd\xec" => 12,            # 
              "\xb3\xe0\xe3\xd4\xdd\xef" => 12,                # 
              "\xb4\xb5\xba" => 12,                            # 
              "\xb4\xb5\xba\xb0\xb1\xc0\xcc" => 12,            # 
              "\xb4\xb5\xba\xb0\xb1\xc0\xcf" => 12,            # 
              "\xb4\xd5\xda" => 12,                            # 
              "\xb4\xd5\xda\xd0\xd1\xe0\xec" => 12,            # 
              "\xb4\xd5\xda\xd0\xd1\xe0\xef" => 12,            # 
              "\xc4\xc5\xca" => 12,                            # 
              "\xc4\xc5\xca\xc0\xc1\xd0\xdc" => 12,            # 
              "\xc4\xc5\xca\xc0\xc1\xd0\xdf" => 12,            # 
              "\xc4\xc5\xcb" => 12,                            # 
              "\xc4\xc5\xcb\xc1\xc2\xd2\xd1" => 12,            # 
              "\xc4\xc5\xcb\xc1\xc2\xd2\xd8" => 12,            # 
              "\xc4\xe5\xea" => 12,                            # 
              "\xc4\xe5\xea\xe0\xe1\xf0\xfc" => 12,            # 
              "\xc4\xe5\xea\xe0\xe1\xf0\xff" => 12,            # 
              "\xc7\xd2\xd5" => 12,                            # 
              "\xc7\xd2\xd5\xc4\xc5\xce\xd8" => 12,            # 
              "\xc7\xd2\xd5\xc4\xce\xd1" => 12,                # 
              "\xd3\xe0\xe3" => 12,                            # 
              "\xd3\xe0\xe3\xd4\xd5\xdd\xec" => 12,            # 
              "\xd3\xe0\xe3\xd4\xdd\xef" => 12,                # 
              "\xd4\xd5\xda" => 12,                            # 
              "\xd4\xd5\xda\xd0\xd1\xe0\xec" => 12,            # 
              "\xd4\xd5\xda\xd0\xd1\xe0\xef" => 12,            # 
              "\xe4\xc5\xcb" => 12,                            # 
              "\xe4\xc5\xcb\xc1\xc2\xd2\xd1" => 12,            # 
              "\xe4\xc5\xcb\xc1\xc2\xd2\xd8" => 12,            # 
              "\xe4\xe5\xea" => 12,                            # 
              "\xe4\xe5\xea\xe0\xe1\xf0\xfc" => 12,            # 
              "\xe4\xe5\xea\xe0\xe1\xf0\xff" => 12,            # 
              "\xe4\xe5\xeb" => 12,                            # 
              "\xe4\xe5\xeb\xe1\xe2\xf2\xf1" => 12,            # 
              "\xe4\xe5\xeb\xe1\xe2\xf2\xf8" => 12,            # 
              "\xe7\xd2\xd5" => 12,                            # 
              "\xe7\xd2\xd5\xc4\xc5\xce\xd8" => 12,            # 
              "\xe7\xd2\xd5\xc4\xce\xd1" => 12,                # 
              "\xe7\xf2\xf5" => 12,                            # 
              "\xe7\xf2\xf5\xe4\xe5\xee\xf8" => 12,            # 
              "\xe7\xf2\xf5\xe4\xee\xf1" => 12,                # 
            );
my $month_rx = '(' . join(')|(',keys %MONTH) . ')';

sub year_correct($)
{
  my ($y) = @_;
  $y += ( $y < 70 )? 2000: 1900 if( $y < 1000 );
  return $y;
}

sub ParseSyslogDate($)
{
  my ($str) = @_;
  my ($H,$M,$S,$d,$m,$y);
  my $cur_time = time();
  my ($cur_H,$cur_d,$cur_m,$cur_y) = (localtime($cur_time))[2,3,4,5];
  $cur_m++; $cur_y+=1900;
  my $cur_ys = $cur_y % 100;

  $str =~ s/^\s+//;
  $str =~ s/\s+$//;
  $str =~ s/\s+/ /g;

  if( $str =~ s!(^|\s)([0-2]?\d)        # hour = $2
                :([0-5]\d)              # min  = $3
                (:
                  ([0-5]\d)             # sec  = $5
                  (([\.,]\d{1,6})?)     # msec = $6
                )?
                \s*(([ap]m)?)           # am/pm = $8
                (?=\s|$)!!ix )
  {
    ($H, $M, $S) = ($2, $3, $5);
    my ($mS, $ampm) = ($6, $8);

    if( $mS )
    {
      $mS =~ s/,/\./;
      $S += $mS;
    }

    if( $ampm && $H>0 && $H<13 )
    {
      $ampm = lc($ampm);
      $H = 0   if( $ampm eq 'am' && $H == 12 );
      $H += 12 if( $ampm eq 'pm' && $H != 12 );
    }
  }
  else
  {
#    warn "Not found time value in string $str\n";
    return undef;
  }

  if( $str =~ s!(^|\s)(d{1,4}([\.-/])d{1,2}\3d{1,4})(?=\s|$)!! )
  {
    my $str = $2;
    if( $str =~ /(\d{4})([\.\/-])(\d{1,2})\2(\d{1,2})/ )
    {
      ($y,$m,$d) = ($1,$3,$4);
    }
    elsif( $str =~ /(\d+)\/(\d+)\/(\d+)/ )
    {
      #  %d/%m/%Y (pt,en,gr,es,hi,am,tr) vs %m/%d/%Y (us,C)
      ($m,$d,$y) = ($1,$2,$3);

      if( $m>12 )
      {
        ($d,$m) = ($m,$d);
      }
      else
      {
        $y = year_correct($y);
        my $parse_time_uk = timelocal($S,$M,$H,$m,$d-1,$y-1900);
        my $parse_time_us = timelocal($S,$M,$H,$d,$m-1,$y-1900);
        my $last_week = $cur_time - 604800;

        ($d,$m) = ($m,$d) if( $parse_time_uk<=$cur_time && ($parse_time_us>$cur_time || ($parse_time_us<$last_week && $parse_time_uk>=$last_week) ) );
      }
    }
    else
    {
      ($d,$m,$y) = ( $str =~ /(\d+)[\.-](\d+)[\.](\d+)/ );
    }
  }
  else
  {
    if( $str =~ s/(^|\s)($month_rx)(?=\s|$)//o )
    {
      $m = $MONTH{$2};
    }

    if( $str =~ s/(^|\s)([0-3]?\d)(?=\s|$)// )
    {
      $d = $2;
    }

    if( $str =~ s/(^|\s)(\d\d(\d\d)?)(?=\s|$)// )
    {
      $y = $2;
    }
  }

  unless(defined $d)
  {
    if( $H==23 && $cur_H==0 )
    {
      ($d,$m,$y) = (localtime($cur_time-7200))[3,4,5];
      $m++;
      $y += 1900;
    }
    else
    {
      ($d,$m,$y) = ($cur_d,$cur_m,$cur_y);
    }
  }

  unless($m)
  {
    if( $d>27 && $cur_d==1 )
    {
      ($m,$y) = (localtime($cur_time-172800))[4,5];
      $m++;
      $y += 1900;
    }
    else
    {
      ($m,$y) = ($cur_m,$cur_y);
    }
  }

  unless(defined $y)
  {
    $y = ( $m==12 && $cur_m==1 )? $cur_y-1: $cur_y;
  }
  else
  {
    $y = year_correct($y);
  }

  return timelocal($S,$M,$H,$d,$m-1,$y-1900);
}

1;
__END__
