#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use vars qw($CONST $CONFIG $LANG $MENU);

#######################################################################
# Menu description data

$MENU = [
          {
            name => $LANG->{menu}{items}{tab_monitoring},
            page => 'ref:index.cgi',
            title => $LANG->{menu}{title}{'index'},
            menu => [
                      {
                        name => $LANG->{menu}{items}{mon_header},
                        page => 'ref:index.cgi',
                        skip_path => 1,
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{status},
                                    page => 'index.cgi',
                                    title => $LANG->{menu}{title}{'index'},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{antispam},
                                    page => 'as_status.cgi',
                                    title => $LANG->{menu}{title}{as_status},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{updates},
                                    page => 'asup_status.cgi',
                                    title => $LANG->{menu}{title}{asup_status},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{license},
                                    page => 'aslic_status.cgi',
                                    title => $LANG->{menu}{title}{aslic_status},
                                    help => undef,
                                  },
                                ],
                      }
                    ],
          },
          {
            name => $LANG->{menu}{items}{tab_statistics},
            page => 'ref:stat.cgi?period=d',
            menu => [
                      {
                        name => $LANG->{menu}{items}{stat_header},
                        page => 'ref:stat.cgi?period=d',
                        skip_path => 1,
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{daily},
                                    page => 'stat.cgi?period=d',
                                    title => $LANG->{menu}{title}{stat_d},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{weekly},
                                    page => 'stat.cgi?period=w',
                                    title => $LANG->{menu}{title}{stat_w},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{monthly},
                                    page => 'stat.cgi?period=m',
                                    title => $LANG->{menu}{title}{stat_m},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{annually},
                                    page => 'stat.cgi?period=y',
                                    title => $LANG->{menu}{title}{stat_y},
                                    help => undef,
                                  },
                                ],
                      },
                    ],
          },
          {
            name => $LANG->{menu}{items}{tab_policy},
            page => 'ref:common_rules_list.cgi',
            drules => '1',
            grules => '1',
            menu => [
                      {
                        name => $LANG->{menu}{items}{pcommon},
                        page => 'ref:common_rules_list.cgi',
                        pmode => 'common',
                        disabled_path => 1,
                        drules => '1',
                        drules_path => 1,
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{rules},
                                    page => 'common_rules_list.cgi',
                                    title => $LANG->{menu}{title}{common_rules},
                                    help => undef,
                                    drules => '1',
                                    menu => [
                                              {
                                                name => $LANG->{menu}{items}{rules_item},
                                                page => 'common_rules.cgi',
                                                title => $LANG->{menu}{title}{common_rules_item},
                                                help => undef,
                                                drules => '1',
                                              },
                                            ],
                                  },
                                  {
                                    name => $LANG->{menu}{items}{blocked},
                                    page => 'common_blocked.cgi',
                                    title => $LANG->{menu}{title}{common_blocked},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{allowed},
                                    page => 'common_allowed.cgi',
                                    title => $LANG->{menu}{title}{common_allowed},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{dnsbl},
                                    page => 'dnsbl.cgi',
                                    title => $LANG->{menu}{title}{dnsbl},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{protected_domains},
                                    page => 'protected_domains.cgi',
                                    title => $LANG->{menu}{title}{protected_domains},
                                    help => undef,
                                  },
                                ],
                      },
                      {
                        name => $LANG->{menu}{items}{pgroup},
                        page => 'ref:group_list.cgi',
                        skip_path => 1,
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{grlist},
                                    page => 'group_list.cgi',
                                    title => $LANG->{menu}{title}{group_list},
                                    help => undef,
                                    menu => [
                                              {
                                                name => $LANG->{menu}{items}{group_new},
                                                page => 'group_members.cgi?new',
                                                title => $LANG->{menu}{title}{group_new},
                                                help => undef,
                                              },
                                            ],
                                  },
                                ],
                      },
                      {
                        name => $LANG->{menu}{items}{single_group},
                        page => '',
                        pmode => 'single',
                        hidden => 1,
                        grules => '1',
                        grules_path => 1,
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{members},
                                    page => 'group_members.cgi',
                                    title => $LANG->{menu}{title}{group_members},
                                    help => undef,
                                    pmode => 'single',
                                    disabled => 1,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{actions},
                                    page => 'group_actions.cgi',
                                    title => $LANG->{menu}{title}{group_actions},
                                    help => undef,
                                    pmode => 'single',
                                  },
                                  {
                                    name => $LANG->{menu}{items}{group_rules},
                                    page => 'group_rules_list.cgi',
                                    title => $LANG->{menu}{title}{group_rules},
                                    help => undef,
                                    pmode => 'single',
                                    grules => '1',
                                    menu => [
                                              {
                                                name => $LANG->{menu}{items}{rules_item},
                                                page => 'group_rules.cgi',
                                                title => $LANG->{menu}{title}{group_rules_item},
                                                help => undef,
                                                pmode => 'single',
                                                grules => '1',
                                              },
                                            ],
                                  },
                                  {
                                    name => $LANG->{menu}{items}{blocked},
                                    page => 'group_blocked.cgi',
                                    title => $LANG->{menu}{title}{group_blocked},
                                    help => undef,
                                    pmode => 'single',
                                  },
                                  {
                                    name => $LANG->{menu}{items}{allowed},
                                    page => 'group_allowed.cgi',
                                    title => $LANG->{menu}{title}{group_allowed},
                                    help => undef,
                                    pmode => 'single',
                                  },
                                ],
                      },
                      {
                        name => $LANG->{menu}{items}{build},
                        page => 'ref:rebuild_policy.cgi',
                        skip_path => 1,
                        pmode => 'common',
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{rebuild_policy},
                                    page => 'rebuild_policy.cgi',
                                    title => $LANG->{menu}{title}{rebuild_policy},
                                    help => undef,
                                  },
                                ],
                      },
                    ],
          },
          {
            name => $LANG->{menu}{items}{tab_settings},
            page => 'ref:settings_common.cgi',
            menu => [
                      {
                        name => $LANG->{menu}{items}{settings_antispam},
                        page => 'ref:settings_common.cgi',
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{settings_common},
                                    page => 'settings_common.cgi',
                                    title => $LANG->{menu}{title}{settings_common},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{settings_server},
                                    page => 'settings_server.cgi',
                                    title => $LANG->{menu}{title}{settings_server},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{settings_filter},
                                    page => 'settings_filter.cgi',
                                    title => $LANG->{menu}{title}{settings_filter},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{settings_checks},
                                    page => 'settings_checks.cgi',
                                    title => $LANG->{menu}{title}{settings_checks},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{settings_clients},
                                    page => 'settings_clients.cgi',
                                    title => $LANG->{menu}{title}{settings_clients},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{settings_messages},
                                    page => 'settings_messages.cgi',
                                    title => $LANG->{menu}{title}{settings_messages},
                                    help => undef,
                                  },
                                ],
                      },
                      {
                        name => $LANG->{menu}{items}{settings_maintenence},
                        page => 'ref:settings_updater.cgi',
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{settings_updater},
                                    page => 'settings_updater.cgi',
                                    title => $LANG->{menu}{title}{settings_updater},
                                    help => undef,
                                  },
                                  {
                                    name => $LANG->{menu}{items}{cc},
                                    page => 'cc.cgi',
                                    title => $LANG->{menu}{title}{cc},
                                    help => undef,
                                  },
                                ],
                      },
                    ],
          },
          {
            name => $LANG->{menu}{items}{tab_license},
            page => 'ref:license.cgi',
            menu => [
                      {
                        name => $LANG->{menu}{items}{license},
                        page => 'ref:license.cgi',
                        skip_path => 1,
                        menu => [
                                  {
                                    name => $LANG->{menu}{items}{lic_info},
                                    page => 'license.cgi',
                                    title => $LANG->{menu}{title}{lic_info},
                                    help => undef,
                                  },
                                ],
                      },
                    ],
          },
        ];

1;
__END__
