#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU @ERR);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'stsconfig.pl';
  require 'rc/design.pl';
  require 'utils.pl';
};


my $error = !STSCFG_IsReady();
my $statuses = STSConfig::get_statuses();
$error = 1 unless $statuses;


print <<SHOW_ONE;

function Show_One(name)
{
  var action = document.getElementById(name+"_action");
  var sendblk = document.getElementById(name+"_sendto_block");
  var editblk1 = document.getElementById(name+"_subject_prefix_block");
  var editblk4 = document.getElementById(name+"_x_header_block");

  var value = action.options[action.selectedIndex].value;

  if( value=="copy" || value=="forward" )
  {
    sendblk.style.display  = "block";
    editblk1.style.display = "block";
    editblk4.style.display = "block";
  }
  else
  {
    sendblk.style.display = "none";

    if( value=="reject" || value=="blackhole" )
    {
      editblk1.style.display = "none";
      editblk4.style.display = "none";
    }
    else
    {
      editblk1.style.display = "block";
      editblk4.style.display = "block";
    }
  }

  return 1;
}

function Show_Groups()
{
SHOW_ONE



if( $error || !$statuses )
{
  print <<ERROR_LIST;
  Show_One("spam");
  Show_One("probable");
  Show_One("formal");
  Show_One("blacklisted");
ERROR_LIST
}
else
{
  foreach my $category (@{$statuses})
  {
    next unless( defined($category) && defined($category->{Name}) && defined($category->{Status}) && defined($category->{ID}) && $category->{Name} ne '' && $category->{Status} ne '' && $category->{ID} ne '' );
    next if( $category->{Status} =~ /^(not[ _]detected)|(trusted)|(normal)/i );
    print qq|  Show_One("$category->{Status}");
|;
  }
}

print <<SHOW_GROUPS;
  return 1;
}
SHOW_GROUPS


__END__

# Old verison of JS-function Show_One

print <<SHOW_ONE;

function Show_One(name)
{
  var action = document.getElementById(name+"_action");
  var sendblk = document.getElementById(name+"_sendto_block");
  var editblk1 = document.getElementById(name+"_subject_prefix_block");
  var editblk2 = document.getElementById(name+"_subject_suffix_block");
  var editblk3 = document.getElementById(name+"_category_block");
  var editblk4 = document.getElementById(name+"_x_header_block");

  var value = action.options[action.selectedIndex].value;

  if( value=="copy" || value=="forward" )
  {
    sendblk.style.display  = "block";
    editblk1.style.display = "block";
    editblk2.style.display = "block";
    editblk3.style.display = "block";
    editblk4.style.display = "block";
  }
  else
  {
    sendblk.style.display = "none";

    if( value=="reject" || value=="blackhole" )
    {
      editblk1.style.display = "none";
      //editblk2.style.display = "none";
      //editblk3.style.display = "none";
      editblk4.style.display = "none";
    }
    else
    {
      editblk1.style.display = "block";
      editblk2.style.display = "block";
      editblk3.style.display = "block";
      editblk4.style.display = "block";
    }
  }

  return 1;
}

function Show_Groups()
{
SHOW_ONE
