#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'rc/design.pl';
  require 'events.pl';
  require 'utils.pl';
};

my $info = $CONST->{etc}{info_label};

my $events = GetEvents(system_info=>1, apfilters=>1, approc_server=>1, crontab=>1, spfd=>1,
                       httpdaemon=>1, kasmilter=>1, nocache=>1);

my %filter        = %{$events->{apfilters}{message}};
my %load_average  = %{$events->{load_average}{message}};
my %filter_id     = %{$events->{filter_id}{message}};
my %proc_server   = %{$events->{approc_server}{message}};
my %monitoring    = %{$events->{crontab_status}{message}};
my %spfd          = %{$events->{spfd_exist}{message}};
my %thttpd        = %{$events->{httpdaemon}{message}};
my %milter        = %{$events->{kasmilter}{message}};


PageOpen('as_status.cgi');
InfoOpen( %{$LANG->{group}{as_status}}, 'time'=>1 );

InfoBlock( title=>$LANG->{control}{status_filter_version}, %filter_id );
InfoBlock( title=>$LANG->{control}{status_process_server}, %proc_server );
InfoBlock( title=>$LANG->{control}{status_filter}, %filter );
InfoBlock( title=>$LANG->{control}{status_spfd}, %spfd );

InfoBlock( title=>$LANG->{control}{status_thttpd}, %thttpd ) unless($events->{httpdaemon}{value} == -1);
InfoBlock( title=>$LANG->{control}{status_milter}, %milter ) unless($events->{kasmilter}{value} == -1);

InfoBlock( title=>$LANG->{control}{status_monitoring}, %monitoring );

#InfoBlock( title=>$LANG->{control}{status_loadaverage}, %load_average ) if defined $load_average{alert};
InfoClose();
ShowLog( %{$LANG->{group}{as_log}}, uri=>'showlog.cgi', type=>'filter' );
PageClose();
