#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'rc/design.pl';
  require 'events.pl';
};

my $info = $CONST->{etc}{info_label};

my $events = GetEvents(licdaemon=>1, license=>1, nocache=>1);

my %product       = %{$events->{lic_product}{message}};
my %license       = %{$events->{lic_type}{message}};
my %valid         = %{$events->{lic_valid}{message}};
my %licdaemon     = %{$events->{licdaemon}{message}};

PageOpen('aslic_status.cgi');
InfoOpen( %{$LANG->{group}{aslic_status}}, 'time'=>1 );
InfoBlock( title=>$LANG->{control}{status_product}, %product );
InfoBlock( title=>$LANG->{control}{status_license}, %license );
if($events->{lic_type}{value} && $events->{lic_type}{message}{alert} ne 'error')
{
  InfoBlock( title=>$LANG->{control}{status_licvalid}, %valid );
}
InfoBlock( title=>$LANG->{control}{status_licdaemon}, %licdaemon );
InfoClose();
ShowLog( %{$LANG->{group}{aslic_log}}, uri=>'showlog.cgi', type=>'license' );
PageClose();
