#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'rc/design.pl';
  require 'events.pl';
};

my $info = $CONST->{etc}{info_label};

my $events = GetEvents(crontab=>1, update=>1);

my %updater       = %{$events->{crontab_updater}{message}};
my %update_info   = %{$events->{update_id}{message}};
my %update_time   = %{$events->{update_time}{message}};


PageOpen('asup_status.cgi');
InfoOpen( %{$LANG->{group}{asup_status}}, 'time'=>1 );
InfoBlock( title=>$LANG->{control}{status_updater}, %updater );
InfoBlock( title=>$LANG->{control}{status_update_info}, %update_info );
InfoBlock( title=>$LANG->{control}{status_last_update}, %update_time );
InfoClose();
ShowLog( %{$LANG->{group}{asup_log}}, uri=>'showlog.cgi', type=>'updater' );
PageClose();
