#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU);

use CGI qw(:standard);
use CGI::Carp;
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'rc/design.pl';
  require 'utils.pl';
  require 'events.pl';
};

my %param = GetParams();
my %error;

if( defined $param{uploaded_file} )
{
  $error{notice} = $LANG->{message}{keyfile_ok};

  if( length($param{uploaded_file}) )
  {
    my $fname = $param{uploaded_filename};
    $fname = '' unless defined $fname;
    $fname =~ s/\.key$//i;
    $fname =~ s#^.*?([^\\/:]+)$#$1#;
    $fname =~ s#([\\/:\x80-\xFF]|\s)#_#mig;
    $fname =~ s#_+#_#mig;

    $fname = sprintf("kas%08lx",time()) unless defined($fname) || $fname eq '';
    $fname .= '.key';

    umask($CONST->{path}{'umask'});

    my $path = "$CONFIG->{FilterTmpConfigPath}/$fname";

    #if( -e $path )
    #{
    #  $error{warning} = $LANG->{error}{licfile_already_exists};
    #  $error{warning} =~ s/\$file/$fname/g;
    #}

    if( open( FILE, ">$path" ) )
    {
      print FILE $param{uploaded_file};
      close FILE;

      unless( InstallKey($path) )
      {
        $error{error} = "$fname: " . $LANG->{error}{error_install_key};
      }
      else
      {
        $error{notice} = "$fname: " . $error{notice};
      }
    }
    else
    {
      $error{error} = $LANG->{error}{cant_open_licfile};
      push @ERR, "$LANG->{error}{cant_open_licfile} $path: $!";
    }
  }
  else
  {
    $error{error} = $LANG->{error}{zero_size_upload};
  }
}

my $events = GetEvents(license=>1, nocache=>1);

my %valid         = %{$events->{lic_valid}{message}};
my %product       = %{$events->{lic_product}{message}};
my %license       = %{$events->{lic_type}{message}};
my @keys;
@keys = @{$events->{lic_key}{ext}} if( $events->{lic_key} && $events->{lic_key}{ext} && @{$events->{lic_key}{ext}} );

PageOpen('license.cgi');
##ErrorBlock( top=>1, %error ) if( $error{error} || $error{warning} || $error{notice} );

InfoOpen( %{$LANG->{group}{license}}, 'time'=>1 );
InfoBlock( title=>$LANG->{control}{status_product}, %product );
InfoBlock( title=>$LANG->{control}{status_license}, %license );
if($events->{lic_type}{value} && $events->{lic_type}{message}{alert} ne 'error')
{
  InfoBlock( title=>$LANG->{control}{status_licvalid}, %valid );
}
InfoClose();

InfoOpen( %{$LANG->{group}{license_keys}} );
InfoClose();
InfoKeyfiles( 'keys'=>\@keys );

FormOpen( action=>$param{this}, title=>$LANG->{group}{license_update}{title}, memo=>$LANG->{group}{license_update}{memo});
FormFile( title=>$LANG->{control}{license_path}, id=>'lic' );
FormSubmitOK( no_reset=>1 );
FormClose();

ErrorBlock( %error );
PageClose();


__END__
