#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU @ERR);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'rc/design.pl';
  require 'utils.pl';
  require 'logs.pl';
};

my %param = GetParams();
my %error;

# Save settings
if( defined $param{ok} )
{
  my $save_map = {
                    LogFacility             => $CONST->{config_map}{LogFacility},
                    LogLevel                => $CONST->{config_map}{LogLevel}
                 };

  $CONFIG->{LogFacility}         = $param{facility}           if defined $param{facility};
  $CONFIG->{LogLevel}            = int($param{loglevel})      if defined $param{loglevel};

  $CONFIG->{LogFacility} = $CONST->{defaults}{LogFacility}
                                unless( $CONFIG->{LogFacility} =~  /^(mail|user|(local[0-7]))$/i );
  $CONFIG->{LogLevel}    = $CONST->{defaults}{LogLevel}
                                if( $CONFIG->{LogLevel} < 0 || $CONFIG->{LogLevel} > 5 );

  $error{notice} = $LANG->{message}{applied};
  $error{error} = $LANG->{error}{cant_save_config}
        unless( WriteConfFile( $CONFIG, $CONFIG->{ConfigPath}, $save_map ) );

  Build_Stat_conf();

  unless( defined($error{error}) )
  {
    $error{warning} = $LANG->{error}{cant_restart_server} unless( RestartServer(server=>1, license=>1) );
  }
}


# Build page
PageOpen('settings_common.cgi');
#ErrorBlock( top=>1, %error ) if( $error{error} || $error{warning} );

FormOpen( action=>$param{this}, %{$LANG->{group}{settings_common}}, 'time'=>1 );

FormSelect( %{$LANG->{control}{facility}}, id=>'facility', selected=>$CONFIG->{LogFacility} );
FormSelect( %{$LANG->{control}{log_level}}, id=>'loglevel', selected=>$CONFIG->{LogLevel} );

FormSubmitOK();
FormClose();

ErrorBlock( %error );
PageClose();
