#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'stsconfig.pl';
  require 'rc/design.pl';
  require 'utils.pl';
};

my %param = GetParams();
my %error;
my $messages = undef;

$error{error} = $LANG->{error}{cant_access_policy_data} unless( STSCFG_IsReady() );

# Save settings
if( defined $param{ok} )
{
  $error{notice} = $LANG->{message}{applied};
  $messages = { BounceMessage=>$param{bounce}, RejectMessage=>$param{reject} };
  STSConfig::set_messages( $messages );
  STSCFG_Succeeded(\%error,'set_messages',$LANG->{error}{cant_save_messages},$LANG->{error}{warn_save_messages});

  unless( defined($error{error}) )
  {
    RestartHelper(\%error);
    STSCFG_ErrorLogHelper(\%error);
  }
}

unless( defined($error{error}) )
{
  $messages = STSConfig::get_messages();
  STSCFG_Succeeded(\%error,'get_messages',$LANG->{error}{cant_access_messages},$LANG->{error}{warn_access_messages});
}

$messages = {} unless defined($messages);
$messages->{BounceMessage} = $CONST->{messages}{bounce} unless defined($messages->{BounceMessage});
$messages->{RejectMessage} = $CONST->{messages}{reject} unless defined($messages->{RejectMessage});


# Build page

PageOpen('settings_messages.cgi');
#ErrorBlock( top=>1, %error ) if( $error{error} || $error{warning} );

FormOpen( action=>$param{this}, %{$LANG->{group}{settings_messages}}, 'time'=>1 );

FormEdit( title=>$LANG->{control}{reject_msg}, id=>'reject', value=>$messages->{RejectMessage} );
FormTextarea( title=>$LANG->{control}{bounce_msg}, id=>'bounce', rows=>10, value=>$messages->{BounceMessage} );

FormSubmitOK();
FormClose();

ErrorBlock( %error );

PageClose();
