#!/usr/local/ap-mailfilter3/bin/perl -w
use strict;

use FindBin qw($Bin);
use lib "$Bin/../lib";

use vars qw($CONST $CONFIG $LANG $MENU @ERR);

use CGI qw(:standard);
use CGI::Carp;
#use POSIX qw(strftime);
use Data::Dumper;

BEGIN {
  require 'cgiutil.pl';
  require 'config.pl';
  require 'rc/design.pl';
  require 'utils.pl';
  require 'logs.pl';
};

sub log_by_datetime
{
  return ( $b->{'time'} != $a->{'time'} )? ($b->{'time'} <=> $a->{'time'}) : ($b->{count} <=> $a->{count});
}


my %param = GetParams();
my $loglevel = $param{level};
$loglevel = 'notice' unless defined($loglevel) && $loglevel =~ /^[inwe]/i;

my %cache_control;
$cache_control{-CACHE_CONTROL} = $CONST->{cgi}{log_cache_control} if defined($CONST->{cgi}{log_cache_control});

print header ( -TYPE => "text/html; charset=$CONFIG->{charset}",
               -EXPIRES => $CONST->{cgi}{log_expires},
               %cache_control
             );

my @log;

if( $param{type} =~ /^updater$/i )
{
  my $log = LoadSyslog( $CONFIG->{CCUpdaterLogPath}, $loglevel );
  if( $log )
  {
    @log = @{$log};
    $log = undef;
  }

  $log = LoadUpdaterLog( $CONFIG->{CCKeepup2dateLogPath}, $loglevel );
  if( $log )
  {
    push @log, @{$log};
    $log = undef;
  }

  @log = sort log_by_datetime (@log);
  my $log_size = scalar(@log);
  splice( @log, 0, $log_size-$CONST->{etc}{logcount_limit} ) if( $log_size > $CONST->{etc}{logcount_limit} );
}
elsif( $param{type} =~ /^filter$/i )
{
  my $log = LoadSyslog( $CONFIG->{CCSyslogLogPath}, $loglevel );
  if( $log )
  {
    @log = sort log_by_datetime (reverse @{$log});
    $log = undef;
  }
}
elsif( $param{type} =~ /^licen(c|s)e$/i )
{
  my $log = LoadSyslog( $CONFIG->{CCSLicenseLogPath}, $loglevel );
  if( $log )
  {
    @log = sort log_by_datetime (reverse @{$log});
    $log = undef;
  }
}

# Log filtration by messages level
#if( $param{level} =~ /^not/i )
#{
#  @log = grep { $_->{status} =~ /^(not|warn|err)/i } @log;
#}
#elsif( $param{level} =~ /^war/i )
#{
#  @log = grep { $_->{status} =~ /^(warn|err)/i } @log;
#}
#elsif( $param{level} =~ /^err/i )
#{
#  @log = grep { $_->{status} =~ /^err/i } @log;
#}
#elsif( $param{level} !~ /^((dbg)|(debug))$/i )
#{
#  # $param{level} eq 'info'
#  @log = grep { $_->{status} =~ /^(inf|not|warn|err)/i } @log;
#}

#my $time_limit = time() - $CONST->{etc}{logtime_limit};
#@log = grep { $_->{'time'} >= $time_limit } @log;

ShowLogFile( 'log'=>\@log );

#############################################################################

__END__
