package STSConfig;

use strict;
use Carp;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $AUTOLOAD);

require Exporter;
require DynaLoader;
require AutoLoader;

@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
  STSCFG_ACCEPT
  STSCFG_ACTION
  STSCFG_ADDRCPT
  STSCFG_ALLOW_EMAIL
  STSCFG_ALLOW_IP
  STSCFG_BLACKHOLE
  STSCFG_BOUNCE
  STSCFG_DEFAULT_GROUP_ID
  STSCFG_DENY_EMAIL
  STSCFG_DENY_IP
  STSCFG_EMPTY
  STSCFG_ERROR_ACTION_CONFIG_NOTFOUND
  STSCFG_ERROR_ACTION_CONFIG_NOTPARSED
  STSCFG_ERROR_API_NOT_INITED
  STSCFG_ERROR_CANT_CREATE_DEF_FILE
  STSCFG_ERROR_CANT_CREATE_LOCK_FILE
  STSCFG_ERROR_CANT_CREATE_XML_FILE
  STSCFG_ERROR_CANT_GET_FILE_SIZE
  STSCFG_ERROR_CANT_LOAD_GROUPS_FILE
  STSCFG_ERROR_CANT_RUN_COMPILER
  STSCFG_ERROR_CANT_RUN_PREPROCESSOR
  STSCFG_ERROR_COMPILER
  STSCFG_ERROR_CONVERT_ARGUMENTS
  STSCFG_ERROR_CREATE_TMP_FILE
  STSCFG_ERROR_EMPTY_LIST
  STSCFG_ERROR_EXEC_KILL_ALL_SCRIPT
  STSCFG_ERROR_FILE_NOT_OPEN  
  STSCFG_ERROR_INIT_CHECKER
  STSCFG_ERROR_MEMORY_ALLOCATION
  STSCFG_ERROR_PREPROCESSOR
  STSCFG_ERROR_RULE_CONFIG_NOTFOUND
  STSCFG_ERROR_RULE_CONFIG_NOTPARSED
  STSCFG_ERROR_USERRULE_CONFIG_PARSING
  STSCFG_ERROR_WRONG_ARGUMENT
  STSCFG_ERROR_WRONG_DEFINE_TYPE
  STSCFG_ERROR_WRONG_EMAIL_ADDRESS
  STSCFG_ERROR_WRONG_GROUP_ID
  STSCFG_ERROR_WRONG_GROUP_OPERATION
  STSCFG_ERROR_WRONG_IP_ADDRESS
  STSCFG_ERROR_WRONG_RBL_ADDRESS
  STSCFG_OK
  STSCFG_MEMBERS
  STSCFG_NEWRCPT
  STSCFG_RBL
  STSCFG_REJECT
  STSCFG_RULE
  STSCFG_STATIC
  STSCFG_TITLE
  STSCFG_CHECK
  STSCFG_EDIT
  STSCFG_NUMBER
  STSCFG_SELECT
  STSCFG_TEXTAREA
  STSCFG_WARN_CANT_APPEND_LOG_FILE
  STSCFG_WARN_LOCK_FILE_EXIST_CANT_COMPILE
);

sub STSCFG_ACCEPT();
sub STSCFG_ACTION();
sub STSCFG_ADDRCPT();
sub STSCFG_ALLOW_EMAIL();
sub STSCFG_ALLOW_IP();
sub STSCFG_BLACKHOLE();
sub STSCFG_BOUNCE();
sub STSCFG_DEFAULT_GROUP_ID();
sub STSCFG_DENY_EMAIL();
sub STSCFG_DENY_IP();
sub STSCFG_EMPTY();
sub STSCFG_ERROR_ACTION_CONFIG_NOTFOUND();
sub STSCFG_ERROR_ACTION_CONFIG_NOTPARSED();
sub STSCFG_ERROR_API_NOT_INITED();
sub STSCFG_ERROR_CANT_CREATE_LOCK_FILE();
sub STSCFG_ERROR_CANT_CREATE_XML_FILE();
sub STSCFG_ERROR_CANT_GET_FILE_SIZE();
sub STSCFG_ERROR_CANT_LOAD_GROUPS_FILE();
sub STSCFG_ERROR_CANT_RUN_COMPILER();
sub STSCFG_ERROR_CANT_RUN_PREPROCESSOR();
sub STSCFG_ERROR_COMPILER();
sub STSCFG_ERROR_CONVERT_ARGUMENTS();
sub STSCFG_ERROR_CREATE_TMP_FILE();
sub STSCFG_ERROR_EMPTY_LIST();
sub STSCFG_ERROR_EXEC_KILL_ALL_SCRIPT();
sub STSCFG_ERROR_FILE_NOT_OPEN();
sub STSCFG_ERROR_INIT_CHECKER();
sub STSCFG_ERROR_MEMORY_ALLOCATION();
sub STSCFG_ERROR_PREPROCESSOR();
sub STSCFG_ERROR_RULE_CONFIG_NOTFOUND();
sub STSCFG_ERROR_RULE_CONFIG_NOTPARSED();
sub STSCFG_ERROR_USERRULE_CONFIG_PARSING();
sub STSCFG_ERROR_WRONG_ARGUMENT();
sub STSCFG_ERROR_WRONG_DEFINE_TYPE();
sub STSCFG_ERROR_WRONG_EMAIL_ADDRESS();
sub STSCFG_ERROR_WRONG_GROUP_ID();
sub STSCFG_ERROR_WRONG_GROUP_OPERATION();
sub STSCFG_ERROR_WRONG_IP_ADDRESS();
sub STSCFG_ERROR_WRONG_RBL_ADDRESS();
sub STSCFG_OK();
sub STSCFG_MEMBERS();
sub STSCFG_NEWRCPT();
sub STSCFG_RBL();
sub STSCFG_REJECT();
sub STSCFG_RULE();
sub STSCFG_STATIC();
sub STSCFG_TITLE();
sub STSCFG_CHECK();
sub STSCFG_EDIT();
sub STSCFG_NUMBER();
sub STSCFG_SELECT();
sub STSCFG_TEXTAREA();
sub STSCFG_WARN_CANT_APPEND_LOG_FILE();
sub STSCFG_WARN_LOCK_FILE_EXIST_CANT_COMPILE();


$VERSION = '0.01';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    croak "& not defined" if $constname eq 'constant';
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
  if ($! =~ /Invalid/) {
      $AutoLoader::AUTOLOAD = $AUTOLOAD;
      goto &AutoLoader::AUTOLOAD;
  }
  else {
    croak "Your vendor has not defined STSConfig macro $constname";
  }
    }
    no strict 'refs';
    *$AUTOLOAD = sub () { $val };
    goto &$AUTOLOAD;
}

sub HasErrors($)
{
  my ($err) = @_;
  return $err < STSCFG_OK;
}

sub HasWarnings($)
{
  my ($err) = @_;
  return $err > STSCFG_OK;
}

sub NoErrors($)
{
  my ($err) = @_;
  return $err >= STSCFG_OK;
}


bootstrap STSConfig $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

STSConfig - Perl extension for blah blah blah

=head1 SYNOPSIS

  use STSConfig;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for STSConfig was created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head1 Exported constants
  STSCFG_ACCEPT
  STSCFG_ACTION
  STSCFG_ADDRCPT
  STSCFG_ALLOW_EMAIL
  STSCFG_ALLOW_IP
  STSCFG_BLACKHOLE
  STSCFG_BOUNCE
  STSCFG_DEFAULT_GROUP_ID
  STSCFG_DENY_EMAIL
  STSCFG_DENY_IP
  STSCFG_EMPTY
  STSCFG_ERROR_ACTION_CONFIG_NOTFOUND
  STSCFG_ERROR_ACTION_CONFIG_NOTPARSED
  STSCFG_ERROR_API_NOT_INITED
  STSCFG_ERROR_CANT_CREATE_LOCK_FILE
  STSCFG_ERROR_CANT_CREATE_XML_FILE
  STSCFG_ERROR_CANT_GET_FILE_SIZE
  STSCFG_ERROR_CANT_LOAD_GROUPS_FILE
  STSCFG_ERROR_CANT_RUN_COMPILER
  STSCFG_ERROR_CANT_RUN_PREPROCESSOR
  STSCFG_ERROR_COMPILER
  STSCFG_ERROR_CONVERT_ARGUMENTS
  STSCFG_ERROR_CREATE_TMP_FILE
  STSCFG_ERROR_EMPTY_LIST
  STSCFG_ERROR_EXEC_KILL_ALL_SCRIPT
  STSCFG_ERROR_FILE_NOT_OPEN
  STSCFG_ERROR_INIT_CHECKER
  STSCFG_ERROR_MEMORY_ALLOCATION
  STSCFG_ERROR_PREPROCESSOR
  STSCFG_ERROR_RULE_CONFIG_NOTFOUND
  STSCFG_ERROR_RULE_CONFIG_NOTPARSED
  STSCFG_ERROR_USERRULE_CONFIG_PARSING
  STSCFG_ERROR_WRONG_ARGUMENT
  STSCFG_ERROR_WRONG_DEFINE_TYPE
  STSCFG_ERROR_WRONG_EMAIL_ADDRESS
  STSCFG_ERROR_WRONG_GROUP_ID
  STSCFG_ERROR_WRONG_GROUP_OPERATION
  STSCFG_ERROR_WRONG_IP_ADDRESS
  STSCFG_ERROR_WRONG_RBL_ADDRESS
  STSCFG_OK
  STSCFG_MEMBERS
  STSCFG_NEWRCPT
  STSCFG_RBL
  STSCFG_REJECT
  STSCFG_RULE
  STSCFG_STATIC
  STSCFG_TITLE
  STSCFG_CHECK
  STSCFG_EDIT
  STSCFG_NUMBER
  STSCFG_SELECT
  STSCFG_TEXTAREA
  STSCFG_WARN_CANT_APPEND_LOG_FILE
  STSCFG_WARN_LOCK_FILE_EXIST_CANT_COMPILE

=head1 AUTHOR

A. U. Thor, a.u.thor@a.galaxy.far.far.away

=head1 SEE ALSO

perl(1).

=cut
