use strict;
use STSConfig;
use Data::Dumper;

my $initdata = {
    		'PrecompilerPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/def',
    		'CompilerPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/def',
    		'XMLPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/src',
		'DefPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/def',
    		'BinDataPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/bin',
    		'CFDataMainsetPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/bin',
  		'BinPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/bin',
    		'FilterConfPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/def/bin',
    		'LockFilePath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tests/data/case1/conf/def/lock.lock',
    		'TempPath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tmp',
    		'Lang' => 'ru_utf8',
    		'MessagesFilePath' => '/home/vvt/work/HEAD/smtp-filter/control-center/config-api/tmp/errors.log',
		'RestartScriptPath' => '',
		'CompileIncremental' => '0'
 		};

print "InitData = ", $initdata->{'BinDataPath'} , "\n";
print Data::Dumper->Dump([$initdata]);

print "Result of init() ", Dumper STSConfig::init($initdata), "\n";
my $err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}
my $c = STSConfig::get_checks();
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}

print "Result of get_checks() ", Dumper $c, "\n";




my $s = STSConfig::get_statuses();
print "Result of get_statuses() ", Dumper $s, "\n";

print "Result of get_base_defines(STSCFG_RULE) ", Dumper STSConfig::get_base_defines(STSConfig::STSCFG_RULE), "\n";
print "Result of get_base_defines(STSCFG_ACTION) ", Dumper STSConfig::get_base_defines(STSConfig::STSCFG_ACTION), "\n";

my $ldr = STSConfig::get_local_defines(STSCFG_ACTION);
print "Result of get_local_defines(STSCFG_ACTION) ", Dumper $ldr, "\n";
print "Result of set_local_defines(STSCFG_ACTION) ", Dumper STSConfig::set_local_defines(STSCFG_ACTION,$ldr), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print " No errors\n";
}
else
{  print " Last error:", $err, "\n";
}
print "Result of get_local_defines(STSCFG_ACTION) ", Dumper STSConfig::get_local_defines(STSCFG_ACTION), "\n";

my $ld = STSConfig::get_local_defines(STSCFG_RULE);
print "Result of get_local_defines(STSCFG_RULE) ", Dumper $ld, "\n";
print "Result of set_local_defines(STSCFG_RULE) ", Dumper STSConfig::set_local_defines(STSCFG_RULE,$ld), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print " No errors\n";
}
else
{  print " Last error:", $err, "\n";
}

print "Result of get_local_defines(STSCFG_RULE) ", Dumper STSConfig::get_local_defines(STSCFG_RULE), "\n";

my $ll = STSConfig::get_local_list(STSCFG_ALLOW_IP);
print "Result of get_local_list(STSCFG_ALLOW_IP) ", Dumper $ll, "\n";
print "Result of set_local_list(STSCFG_ALLOW_IP) ", Dumper STSConfig::set_local_list(STSCFG_ALLOW_IP,$ll), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}
print "Result of get_local_list(STSCFG_ALLOW_IP) ", Dumper STSConfig::get_local_list(STSCFG_ALLOW_IP), "\n";

print "Result of get_local_list(STSCFG_DENY_IP) ", Dumper STSConfig::get_local_list(STSCFG_DENY_IP), "\n";

my $le = STSConfig::get_local_list(STSCFG_ALLOW_EMAIL);
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}
print "Result of get_local_list(STSCFG_ALLOW_EMAIL) ", Dumper  $le, "\n";
print "Result of set_local_list(STSCFG_ALLOW_EMAIL) ", Dumper STSConfig::set_local_list(STSCFG_ALLOW_EMAIL,$le), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}
print "Result of get_local_list(STSCFG_DENY_EMAIL) ", Dumper STSConfig::get_local_list(STSCFG_DENY_EMAIL), "\n";
print "Result of get_local_list(STSCFG_RBL) ", Dumper STSConfig::get_local_list(STSCFG_RBL), "\n";

print "Result of get_groups() ", Dumper STSConfig::get_groups(), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}


my $gid = STSConfig::add_group({'Name' => '"', 'Memo' => " & ⪠\n \'\' \"㯯\""});
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}
print "Result of add_group(): GID = ", $gid , "\n";

print "Result of set_group_defines(STSCFG_RULE) ", Dumper STSConfig::set_group_defines($gid,STSCFG_RULE,$ldr), "\n";
print "Result of set_group_list(STSCFG_ALLOW_IP) ", Dumper STSConfig::set_group_list($gid,STSCFG_ALLOW_IP,$ll), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}

my @lst = ({'Entry' => 'vic@mic.ru'}, {'Entry' => 'test'});
my $lty_ref = \@lst; 
print ": ", Dumper $lty_ref, "\n";
print "Result of set_group_list(STSCFG_DENY_IP) ", Dumper STSConfig::set_group_list($gid, STSCFG_DENY_EMAIL, $lty_ref), "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}


print "Result of remove_group(5): ", Dumper STSConfig::remove_group(5) , "\n";
print "Result of remove_group(6): ", Dumper STSConfig::remove_group(6) , "\n";


print "Result of get_group(2): ", Dumper STSConfig::get_group(2) , "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}

my $mygroup = {
    		'Name' => 'New group % & < > name',
    		'Memo' => "Memo \' memo \' memo\nTest & drive\n"
		};

print "Result of set_group(2): ", Dumper STSConfig::set_group(2,$mygroup) , "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}

print "Result of get_group(2): ", Dumper STSConfig::get_group(2) , "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}

my @reord = (2,4,1,3);
my $lst = \@reord;

print "Order list: ", Dumper @reord , "\n";

print "Result of reorder_groups(): ", Dumper STSConfig::reorder_groups($lst) , "\n";
$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}
   
print "Result of get_groups() ", Dumper STSConfig::get_groups(), "\n";


print "Result of get_messages() ", Dumper STSConfig::get_messages(), "\n";
print "Result of set_messages(HV) ", Dumper STSConfig::set_messages({'RejectMessage' => 'Reject message sample1', 'BounceMessage' => 'This is bounce message sample1'}), "\n";
print "Result of get_messages() ", Dumper STSConfig::get_messages(), "\n";

my $cfg = STSConfig::get_filter_config();
print "Result of stscfg_get_filter_config() ", Dumper $cfg, "\n";
print "Result of stscfg_set_filter_config(AV) ", Dumper STSConfig::set_filter_config($cfg), "\n";

$err = STSConfig::get_last_error();
if ($err == STSCFG_OK)
{
  print "No errors\n";
}
else
{  print "Last error:", $err, "\n";
}

print "Result of release() ", Dumper STSConfig::release(), "\n";

